# GravityWise Plugin

Contributors: 
Tags: gravity forms, connectwise
Requires at least: 4.6.0
Tested up to: 5.9
Stable tag: 1.0.0
License: GPLv2 or later

## Description

An add-on to the popular Gravity Forms WordPress plugin that adds an integration to allow users to query the ConnectWise CRM making form entry both easier and more organized.

## Features

 - New fields are added to Gravity Forms.
 - Use data from your ConnectWise installation to improve the experience of filling out forms.
 - Filter data using advanced condition logic.
 - Format data to be displayed just the way you wish.

## Future Features

 - Create custom feeds that integrate with ConnectWise
 - Create a Data Table field.

## Dependencies

 - [Gravity Forms](https://www.gravityforms.com/) (Standalone)
 - [Freemius](https://freemius.com/) (Included)
 - [Vue.js](https://vuejs.org/) (Included via CDN)
 - [Vue-Multiselect](https://vue-multiselect.js.org/) (Included via CDN)
 
## Installation

 To install this plugin, follow these instructions.
 1. Login or create a WordPress website. For local development, follow the instructions here: [Install WordPress Locally With MAMP](https://athemes.com/tutorials/install-wordpress-locally-using-mamp/)
 2. Install [Gravity Forms](https://www.gravityforms.com/) to your WordPress installation. An installation of Gravity Forms is required for the ConnectWise plugin to work.
 3. Place this plugin in the \wp-content\plugins folder.
 4. Within WordPress, navigate to the Plugins menu. Verify that Gravity Forms is activated, then Activate GravityWise Plugin

## Configuring ConnectWise
 To configure ConnectWise, follow these instructions.
 1. Within WordPress navigate to the Forms/Settings menu.
 2. Within General Settings navigate to GravityWise Add-On
 3. Complete the ConnectWise Account Information Section using your business' ConnectWise Account.
 4. You may then optionally configure errors to be sent to an email address.

## Create a Form

To create your first form, follow these instructions.
1. Navigate to Forms/New Form
2. Give your form a title and a description.
3. Expand the ConnectWise Fields section.
4. Drag in a CW Dropdown or a CW Lookup field.
5. Click on the field to open the settings.
6. Type a name into the Field Label Section.
7. Select a ConnectWise component that the user will select from.
8. Click the Update form to the right.
9. Click the preview button at the top to verify that the form works.

## Advanced Settings

To use conditions and merge tags follow these instructions.
1. Within the form editor navigate to the Advanced settings tab of a ConnectWise component.
2. Enable the Conditions text box.
3. Select a ConnectWise property from the dropdown, as well as an operator.
4. In the select option box, you may create a merge tag. Select a property from another Field to use user entered data within a condition.
5. You may select sorting within the Order By section
6. The fields section allows you to filter the data that is shown to the user.
7. The Results View Template Section allows you to use merge tags to format the data that is shown to the user.
8. The Limit section allows you to limit the number of entries to be included, potentially giving performance improvements.
9. Click the Update form to the right.
10. Click the preview button at the top to verify that the form works.