<?php
/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

/**
 * @package gravitywise
 */

defined('ABSPATH') or die('You don\'t have access, silly');

if (!class_exists('GFForms')) {
    die();
}

require_once ABSPATH . '/wp-content/plugins/gravitywise/gf-addon/fields/cw-field-base.php';


/**
 * Class bizz_GravityFormsCwField
 */
if (!class_exists('bizz_GravityFormsCwMultiselectField')) {
    class bizz_GravityFormsCwMultiselectField extends bizz_GravityFormsCwField
    {
        public $type = 'cw_multiselect';

        public function get_form_editor_field_title()
        {
            return esc_attr__('CW Multiselect', 'gfaddon');
        }

        public function get_form_editor_field_icon()
        {
            return 'gform-icon--multi-select';
        }

        public function get_field_input($form, $value = '', $entry = null)
        {
            $form_id    = absint($form['id']);
            $id         = $this->id;
            $cwSettings = $this->cwSettings;

            ob_start();
            include ABSPATH . '/wp-content/plugins/gravitywise/public/js/vue-old/fields/multiselect-field.php';
            return ob_get_clean();
        }
    }

    GF_Fields::register(new bizz_GravityFormsCwMultiselectField());
}
