<?php
/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

/**
 * @package gravitywise
 */

defined('ABSPATH') or die('You don\'t have access, silly');

if (!class_exists('GFForms')) {
    die();
}

require_once ABSPATH . '/wp-content/plugins/gravitywise/gf-addon/fields/cw-field-base.php';

/**
 * Class bizz_GravityFormsCwField
 */
if (!class_exists('bizz_GravityFormsCwTableField')) {
    class bizz_GravityFormsCwTableField extends bizz_GravityFormsCwField
    {
        public $type = 'cw_table';

        public function get_form_editor_field_title()
        {
            return esc_attr__('CW Table', 'gfaddon');
        }

        public function get_form_editor_field_icon()
        {
            return 'gform-icon--entries';
        }

        public function get_field_input($form, $value = '', $entry = null)
        {
            $form_id    = absint($form['id']);
            $id         = $this->id;
            $cwSettings = $this->cwSettings;

            ob_start();
            include ABSPATH . '/wp-content/plugins/gravitywise/public/js/vue-old/fields/table-field.php';
            return ob_get_clean();
        }

        public function get_form_editor_field_settings()
        {
            return array(
                'conditional_logic_field_setting',
                'error_message_setting',
                'label_setting',
                'label_placement_setting',
                'admin_label_setting',
                'size_setting',
                'connectwise_components_standard_settings',
                'connectwise_components_advanced_settings',
                'rules_setting',
                'visibility_setting',
                'duplicate_setting',
                'description_setting',
            );
        }
    }

    GF_Fields::register(new bizz_GravityFormsCwTableField());
}
