<?php

/*
Plugin Name: GravityWise
Plugin URI: https://www.bizztoolz.com/
Version: 1.0.0
Author: BizZToolz
Author: https://www.bizztoolz.com/
Description: API integration between ConnectWise and Gravity Forms.
License: GPL2
Text-Domain: gravitywise
*/
/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/
defined( 'ABSPATH' ) or die;
add_action( 'wp_head', 'bizz_register_vue' );
add_action( 'admin_head', 'bizz_register_vue' );
register_activation_hook( __FILE__, 'bizz_gravitywise_activation_hook' );
function bizz_gravitywise_activation_hook()
{
    require_once ABSPATH . 'wp-content/plugins/gravitywise/includes/feeds/entry-mapper.php';
    require_once ABSPATH . 'wp-content/plugins/gravitywise/includes/feeds/action-mapper.php';
    bizz_ActionMapper::init_table();
    bizz_EntryMapper::init_table();
}

function bizz_register_vue()
{
    echo  "<script src='https://cdn.jsdelivr.net/npm/vue@2'></script>" ;
    //   echo "<script src='https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js'></script>";
    echo  "<script src='https://unpkg.com/vue-multiselect@2.1.0'></script>" ;
    echo  "<link rel='stylesheet' href='" . plugins_url( '/public/css/vue_multiselect.css', __FILE__ ) . "'>" ;
    echo  "<link rel='stylesheet' href='" . plugins_url( '/public/css/feed_builder_styles.css', __FILE__ ) . "'>" ;
    echo  "<link rel='stylesheet' href='" . plugins_url( '/public/css/feed_retry.css', __FILE__ ) . "'>" ;
    echo  "<link rel='stylesheet' href='" . plugins_url( '/public/css/cw_fields.css', __FILE__ ) . "'>" ;
    echo  "<link rel='stylesheet' href='" . plugins_url( '/public/css/fields_2_5.css', __FILE__ ) . "'>" ;
    echo  "<link rel='stylesheet' href='" . plugins_url( '/public/css/feed_builder_2_5.css', __FILE__ ) . "'>" ;
    echo  "<script src='https://use.fontawesome.com/dfd62fb536.js'></script>" ;
    echo  "<script src='https://unpkg.com/vuex@3.6.2/dist/vuex.js'></script>" ;
    echo  "<script src='" . plugins_url( '/public/js/common/filter-encoder.js', __FILE__ ) . "'></script>" ;
    echo  "<script src='" . plugins_url( '/public/js/common/cw-helper.js', __FILE__ ) . "'></script>" ;
    echo  "<script src='" . plugins_url( '/public/js/common/merge-tags.js', __FILE__ ) . "'></script>" ;
    echo  "<script src='" . plugins_url( '/public/js/vue-old/components/cwMixin.js', __FILE__ ) . "'></script>" ;
    echo  "<script src='" . plugins_url( '/public/js/vue-old/components/fieldClass.js', __FILE__ ) . "'></script>" ;
    echo  "<script src='" . plugins_url( '/public/js/vue-old/components/mergeTag.js', __FILE__ ) . "'></script>" ;
    echo  "<script src='" . plugins_url( '/public/js/vue-old/components/multiStatementField.js', __FILE__ ) . "'></script>" ;
    echo  "<script src='" . plugins_url( '/public/js/vue-old/components/commonComponents.js', __FILE__ ) . "'></script>" ;
    echo  "<link rel='stylesheet' href='" . plugins_url( '/../gravityforms/css/font-awesome.min.css', __FILE__ ) . "'></style>" ;
}

add_action( 'init', 'bizz_init_session' );
function bizz_init_session()
{
    session_start();
}

add_filter( 'gform_pre_render', 'bizz_generate_form_guid' );
function bizz_generate_form_guid( $form )
{
    bizz_register_vue();
    global  $guid ;
    $guid = uniqid( "U" );
    $_SESSION[$guid] = bizz_stripForm( $form['id'] );
    echo  "<script type='text/javascript'>var cwAddonGuid='{$guid}';</script>" ;
    return $form;
}

function bizz_stripForm( $form_id )
{
    global  $wpdb ;
    $form = json_decode( $wpdb->get_results( $wpdb->prepare( "SELECT \r\n                display_meta \r\n            FROM \r\n                {$wpdb->prefix}gf_form_meta\r\n            WHERE \r\n                form_id=%d", $form_id ) )[0]->display_meta );
    $res = array();
    foreach ( $form->fields as $key => $value ) {
        $res[$value->id] = array(
            'value' => $value->defaultValue,
        );
        
        if ( strpos( $value->type, 'cw_' ) === 0 ) {
            $res[$value->id]['component'] = $value->cwSettings->cwComponentField;
            $res[$value->id]['filters'] = $value->cwSettings->advancedFilters;
        }
    
    }
    return json_encode( $res );
}


if ( !function_exists( 'gravitywise_freemius_sdk' ) ) {
    // Create a helper function for easy SDK access.
    function gravitywise_freemius_sdk()
    {
        global  $gravitywise_freemius_sdk ;
        
        if ( !isset( $gravitywise_freemius_sdk ) ) {
            // Include Freemius SDK.
            require_once dirname( __FILE__ ) . '/freemius/start.php';
            $gravitywise_freemius_sdk = fs_dynamic_init( array(
                'id'             => '6692',
                'slug'           => 'gravitywise',
                'type'           => 'plugin',
                'public_key'     => 'pk_1754f31abdff908b15da4215bdcea',
                'is_premium'     => false,
                'has_addons'     => false,
                'has_paid_plans' => true,
                'menu'           => array(
                'first-path' => 'admin.php?page=gf_settings&subview=gravitywise',
            ),
                'is_live'        => true,
            ) );
        }
        
        return $gravitywise_freemius_sdk;
    }
    
    // Init Freemius.
    gravitywise_freemius_sdk();
    // Signal that SDK was initiated.
    do_action( 'gravitywise_loaded' );
}


if ( !class_exists( 'gravitywise_bootstrap' ) ) {
    define( 'GRAVITYWISE_FIELD_VERSION', '2.0.0' );
    define( 'GRAVITYWISE_FEED_VERSION', '2.0.0' );
    add_action( 'gform_loaded', array( 'gravitywise_bootstrap', 'loadField' ), 5 );
    add_action( 'gform_loaded', array( 'gravitywise_bootstrap', 'loadFeed' ), 6 );
    class gravitywise_bootstrap
    {
        public static function loadFeed()
        {
            if ( !method_exists( 'GFForms', 'include_feed_addon_framework' ) ) {
                return;
            }
            require_once 'gf-addon/gravitywise-feed-addon.php';
            GFAddOn::register( 'bizz_GravitywiseFeedAddOn' );
        }
        
        public static function loadField()
        {
            if ( !method_exists( 'GFForms', 'include_Addon_framework' ) ) {
                return;
            }
            require_once 'gf-addon/gravitywise-field-addon.php';
            GFAddOn::register( 'bizz_GravitywiseFieldAddOn' );
        }
    
    }
}

add_action( 'admin_notices', 'admin_notice' );
function admin_notice()
{
    
    if ( current_user_can( 'administrator' ) ) {
        $settings = get_option( 'gravityformsaddon_gravitywise_settings' );
        $companyId = $settings['company_id'];
        $site = $settings['cw_site'];
        
        if ( empty($companyId) || empty($site) ) {
            $class = 'notice notice-error';
            $settings_link = '<a href="admin.php?page=gf_settings&subview=gravitywise">API settings</a>';
            $message = sprintf( __( 'The <strong>GravityWise</strong> plugin requires that you configure the %1$s for your ConnectWise install.' ), $settings_link );
            printf( '<div class="%1$s"><p>%2$s</p></div>', esc_attr( $class ), $message );
        }
    
    }

}
