<?php
/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

define("ABSPATH", dirname(__FILE__, 7) . "/");
require_once ABSPATH . '/wp-content/plugins/gravitywise/includes/common/connectwise-client.php';
require_once ABSPATH . '/wp-load.php';
require_once ABSPATH . '/wp-content/plugins/gravitywise/includes/feeds/duplicate-match.php';

header('Content-Type: application/json');
$results = ['Affirmative' => [], 'Adversarial' => []];


$cw_api = new bizz_ConnectwiseClient();

$results['Affirmative']['Generic']['Perfect match with Name'] = bizz_DuplicateMatch::detect_duplicate($cw_api, '/sales/opportunities', (object)['name' => 'CB']);
$results['Adversarial']['Generic']['Perfect match with Name'] = !bizz_DuplicateMatch::detect_duplicate($cw_api, '/sales/opportunities', (object)['name' => 'CBDuplicateTest']);
$results['Affirmative']['Generic']['Perfect match with Title'] = bizz_DuplicateMatch::detect_duplicate($cw_api, '/system/members', (object)['title' => 'Promoted to Customer']);
$results['Adversarial']['Generic']['Perfect match with Title'] = !bizz_DuplicateMatch::detect_duplicate($cw_api, '/system/members', (object)['title' => 'Blarg Blarg Blarg']);
$results['Affirmative']['Generic']['Perfect match with Summary'] = bizz_DuplicateMatch::detect_duplicate($cw_api, '/service/tickets', (object)['summary' => 'Evaluation Rules Overview']);
$results['Adversarial']['Generic']['Perfect match with Summary'] = !bizz_DuplicateMatch::detect_duplicate($cw_api, '/service/tickets', (object)['summary' => 'Blarg Blarg Blarg']);



$results['Affirmative']['contact']['Phone Match'] = bizz_DuplicateMatch::detect_duplicate($cw_api, '/company/contacts', (object)['defaultPhoneNbr' => '8134634700']);
$results['Adversarial']['contact']['Phone Match'] = !bizz_DuplicateMatch::detect_duplicate($cw_api, '/company/contacts', (object)['defaultPhoneNbr' => '1094128023']);
$results['Affirmative']['contact']['Email Match'] = bizz_DuplicateMatch::detect_duplicate(
    $cw_api,
    '/company/contacts',
    (object)[
        'communicationItems' =>
        [
            (object) [
                'type' =>
                (object)[
                    'name' => 'Email'
                ],
                'value' => 'sales@bngteam.com'
            ]
        ]
    ]
);
$results['Adversarial']['contact']['Email Match'] = !bizz_DuplicateMatch::detect_duplicate(
    $cw_api,
    '/company/contacts',
    (object)[
        'communicationItems' =>
        [
            (object) [
                'type' =>
                (object)[
                    'name' => 'Email'
                ],
                'value' => 'bob@blarg.com'
            ]
        ]
    ]
);


$results['Affirmative']['Company']['Company with hard match and more than 50% similarity'] = bizz_DuplicateMatch::detect_duplicate(
    $cw_api,
    '/company/companies',
    (object)['name' => 'BNG Teams', 'phoneNumber' => '7015263539']
);
$results['Affirmative']['Company']['Company with hard match but requires replacements to meet threshold'] = bizz_DuplicateMatch::detect_duplicate(
    $cw_api,
    '/company/companies',
    (object)['name' => 'BNG Team LLC', 'phoneNumber' => '7015263539']
);
$results['Adversarial']['Company']['Company with hard match and less than 50% similarity'] = !bizz_DuplicateMatch::detect_duplicate(
    $cw_api,
    '/company/companies',
    (object)['name' => 'Blarg Blarg Blarg Blarg Blarg', 'phoneNumber' => '7015263539']
);
$results['Affirmative']['Company']['90% match with same Zip'] = bizz_DuplicateMatch::detect_duplicate(
    $cw_api,
    '/company/companies',
    (object)['name' => 'BNG Teams', 'zip' => '58104']
);
$results['Adversarial']['Company']['90% match with same Zip'] = !bizz_DuplicateMatch::detect_duplicate(
    $cw_api,
    '/company/companies',
    (object)['name' => 'BNG Teams', 'zip' => '12345']
);
$results['Affirmative']['Company']['90% match with same state'] = bizz_DuplicateMatch::detect_duplicate(
    $cw_api,
    '/company/companies',
    (object)['name' => 'BNG Teams', 'state' => 'ND']
);
$results['Adversarial']['Company']['90% match with same state'] = !bizz_DuplicateMatch::detect_duplicate(
    $cw_api,
    '/company/companies',
    (object)['name' => 'BNG Teams', 'state' => 'HI']
);
$results['Affirmative']['Company']['90% match with same city and state'] = bizz_DuplicateMatch::detect_duplicate(
    $cw_api,
    '/company/companies',
    (object)['name' => 'BNG Teams', 'city' => 'Fargo', 'state' => 'ND']
);
$results['Adversarial']['Company']['90% match with same city and state'] = !bizz_DuplicateMatch::detect_duplicate(
    $cw_api,
    '/company/companies',
    (object)['name' => 'BNG Teams', 'city' => 'Monticello', 'state' => 'MN']
);


echo json_encode($results);
