<?php
/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

define("ABSPATH",dirname(__FILE__,7)."/");
require_once ABSPATH . '/wp-load.php';
require_once ABSPATH . '/wp-content/plugins/gravitywise/includes/common/merge-tags.php';
require_once ABSPATH . '/wp-content/plugins/gravitywise/includes/common/connectwise-client.php';

if(current_user_can('administrator')){
    $eid = $_GET['eid'];
	$fid = $_GET['fid'];
    global $wpdb;
    $res = [];
    $res['details'] = $wpdb->get_results($wpdb->prepare(
        "SELECT
            id,
            date_created,
            date_updated,
            ip
        FROM
            {$wpdb->prefix}gf_entry A
        WHERE A.id = %d", $eid    
    ))[0];
    $res['notes'] = $wpdb->get_results($wpdb->prepare(
        "SELECT
            *
        FROM
            {$wpdb->prefix}gf_entry_notes A
        WHERE
            A.entry_id = %d
    ",$eid
    ));
    $res['actions'] = $wpdb->get_results($wpdb->prepare(
        "SELECT
                A.*
        FROM
            {$wpdb->prefix}cw_action_attempt A
            LEFT JOIN {$wpdb->prefix}cw_entry_attempt B ON A.entry_attempt_id = B.id
        WHERE
            B.entry_id = %d and B.feed_id = %d
        ",$eid, $fid
    ));

    $cw_api = new bizz_ConnectwiseClient();
    foreach ($res['actions'] as $action){
    	if($action->merge_id != 0){
    		$data = $cw_api->getCwData(json_decode($action->meta)->endpoint . '/' . $action->merge_id,'');
	        $action->merge_json = json_encode($data);
    	}
    }


    if(!headers_sent()){
        header('Content-Type: application/json');
    }
    echo json_encode($res);
        

}else{
    http_response_code(403);
}