<?php
/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

define("ABSPATH",dirname(__FILE__,7)."/");
require_once ABSPATH . '/wp-load.php';
require_once ABSPATH . '/wp-content/plugins/gravitywise/includes/common/merge-tags.php';
require_once ABSPATH . '/wp-content/plugins/gravitywise/includes/common/connectwise-client.php';
require_once ABSPATH . '/wp-content/plugins/gravitywise/includes/feeds/feed-dispatcher.php';



if(current_user_can('administrator')){
    global $wpdb;
    $query = $wpdb->get_results(
    "SELECT
    C.meta as feed_meta,
    C.id as feed_id,
    A.dismissed as dismissed,
    A.id as id,
    D.title as form_name,
    D.id as form_id,
    B.id as entry_id,
    B.date_created as date_created,
    
    (
        SELECT
            COUNT(X.status)
        FROM
            {$wpdb->prefix}cw_action_attempt as X
        WHERE
            X.entry_attempt_id = A.id
            AND X.status = 'Success'
            OR X.status = 'Revert'
    ) as current_status,
    (
        SELECT
            COUNT(X.status)
        FROM
            {$wpdb->prefix}cw_action_attempt as X
        WHERE
            X.entry_attempt_id = A.id
    ) as total_status,
    (
        SELECT
            status
        FROM
            {$wpdb->prefix}cw_action_attempt as X
        WHERE
        	X.entry_attempt_id = A.id
        ORDER BY
            X.status ASC
        LIMIT
            1
    ) as status,
    A.condition_validated as condition_validated
FROM
    {$wpdb->prefix}cw_entry_attempt A
    LEFT JOIN {$wpdb->prefix}gf_entry B ON A.entry_id = B.id
    LEFT JOIN {$wpdb->prefix}gf_addon_feed C ON A.feed_id = C.id
    LEFT JOIN {$wpdb->prefix}gf_form D ON B.form_id = D.id;"    
    );

    header('Content-Type: application/json');
    echo json_encode($query);
        

}else{
    http_response_code(403);
}