<?php
/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

	if(!defined("ABSPATH")){
        define("ABSPATH",dirname(__FILE__,7)."/");
	}
	require_once ABSPATH . '/wp-load.php';
    require_once ABSPATH . '/wp-content/plugins/gravitywise/includes/feeds/feed-dispatcher.php';

	$settings = get_option('gravityformsaddon_gravitywise_settings');

	if($settings['data_policy']==='30'){
		global $wpdb;
		$stale = $wpdb->get_results(
			$wpdb->prepare(
				"SELECT *
FROM
    {$wpdb->prefix}gf_entry
WHERE
    date_created < DATE_SUB(CURDATE(), INTERVAL 30 DAY);",''
			)
		);

		foreach ($stale as $record){
			$target = $record->id;
			$wpdb->query(
				$wpdb->prepare(
					"DELETE FROM {$wpdb->prefix}gf_entry WHERE id= %d",$target
				)
			);
			$wpdb->query(
				$wpdb->prepare(
					"DELETE FROM {$wpdb->prefix}gf_entry_meta WHERE entry_id= %d",$target
				)
			);
			$wpdb->query(
				$wpdb->prepare(
					"DELETE FROM {$wpdb->prefix}gf_entry_notes WHERE entry_id= %d",$target
				)
			);
			$entryAttempt = $wpdb->get_results(
				$wpdb->prepare(
					"SELECT * FROM
						    {$wpdb->prefix}cw_entry_attempt
						WHERE
						    entry_id= %d",$target
				)
			);
			$wpdb->query(
				$wpdb->prepare(
					"DELETE FROM {$wpdb->prefix}cw_entry_attempt WHERE entry_id= %d",$target
				)
			);
			$wpdb->query(
				$wpdb->prepare(
					"DELETE FROM {$wpdb->prefix}cw_action_attempt WHERE entry_attempt_id= %d",$entryAttempt[0]->id
				)
			);
		}
	}

    $d = new bizz_FeedDispatcher(new bizz_ConnectwiseClient());
    $d->generate_new_entries();
    $d->process_entries();