<?php
/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

define("ABSPATH",dirname(__FILE__,7)."/");
require_once ABSPATH . '/wp-load.php';
require_once ABSPATH . '/wp-content/plugins/gravitywise/includes/common/merge-tags.php';
require_once ABSPATH . '/wp-content/plugins/gravitywise/includes/common/connectwise-client.php';
require_once ABSPATH . "/wp-content/plugins/gravitywise/includes/feeds/entry-mapper.php";
require_once ABSPATH . "/wp-content/plugins/gravitywise/includes/feeds/action-mapper.php";

if (!current_user_can('administrator')) {
    die();
}
if (!isset($_POST['id'])) {
    die();
}

$attempt = bizz_EntryMapper::get_entry_attempt($_POST['entry_id']);
$attempt->fetch_actions();
$response = null;

if (isset($_POST['force']) && $_POST['force']==='true') {
    foreach ($attempt->actions as $key => $value) {
        if($value->id == $_POST['id']){
            $meta = bizz_EntryMapper::get_feed_meta($attempt->feed_id)['CWFeedSettings']['actions'];
            $value->meta = (array) $meta[$key];
            $value->value = (array) $meta[$key]['request'];
            $value->status = 'Wait';
            bizz_ActionMapper::update_action_attempt($value);
            $attempt->set_merge_tag();
            $attempt->process_actions(new bizz_ConnectwiseClient());
            $response = $value;
        }
    }
}else{
    foreach ($attempt->actions as $key => $value) {
        if($value->id == $_POST['id']){
            $request = $value->build_request(false);
            $api = new bizz_ConnectwiseClient();
            $value->execute_request($request, $api);
            $response = $value;
            if($value->status=='Success'){
                $attempt->set_merge_tag();
                $attempt->process_actions($api);
            }
        }
    }
}
header('Content-Type: application/json'); 
echo json_encode(bizz_ActionMapper::get_action_attempt($response->id));