<?php
/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

if (!defined('ABSPATH')) {
	define("ABSPATH",dirname(__FILE__,7)."/");
}
require_once ABSPATH . '/wp-load.php';
session_start();
require_once ABSPATH . '/wp-content/plugins/gravitywise/includes/common/merge-tags.php';
require_once ABSPATH . '/wp-content/plugins/gravitywise/includes/common/connectwise-client.php';

$GUID = $_GET['guid'];
$field_id = $_GET['field'];
$search_str = $_GET['search'] ?? '';
$search_str = urldecode($search_str);
$search_str = preg_replace('/[^-a-zA-Z0-9_]/', '', $search_str);

header('Content-Type: application/json');

if (isset($_SESSION[$GUID])) {
	$form_data = json_decode($_SESSION[$GUID],true);
	$field_data = $form_data[$field_id];
	if (isset($field_data['component'])) {
		$cw_api = new bizz_ConnectwiseClient();
		$mt_parser = new bizz_MergeTags($form_data);
		$mt_value = $mt_parser->replaceMergeTags($field_data['filters']);
		if($search_str !== ''){
			if(preg_match('/conditions=/',$mt_value)){
				$mt_value = preg_replace('/conditions=/','conditions=name%20contains%20%22'.$search_str. '%22%20AND%20',$mt_value);
			}else{
				$mt_value .= '&conditions=name%20contains%20%22'. $search_str.'%22';
			}
		}
		echo json_encode($cw_api->getCwData($field_data['component']['endpoint'], $mt_value));
	}
}
