<?php
/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

class bizz_LegacyMigration {

//{"name":"Contact Feed","CWFeedSettings":{"name":"Contact Feed","conditions":{"active":false,"conjunction":"ANY","statements":[{"property":"Id","operator":"","value":""}]},"actions":[{"id":1,"type":"Create","component":{"name":"Company","endpoint":"\/company\/companies"},"request":{"identifier":"{Company:9}","name":"{Company:9}","site":{"id":"","name":"Main Site"}},"duplicatePolicy":"reckless"},{"id":1,"type":"Create","component":{"name":"Contact","endpoint":"\/company\/contacts"},"request":{"identifier":"{Company:9}","name":"{Company:9}","site":{"id":"","name":"Main Site"}},"duplicatePolicy":"none"},{"id":1,"type":"Create","component":{"name":"Opportunity","endpoint":"\/sales\/opportunities"},"request":{"identifier":"{Company:9}","name":"{Company:9}","site":{"id":"","name":"Main Site"}},"duplicatePolicy":"none"}],"email":{"active":false,"onSubmit":false,"onFail":false,"onSuccess":false,"addresses":""}}}

	public function query_legacy_feeds(){
		global $wpdb;
		return $wpdb->get_results(
			$wpdb->prepare("
				SELECT
				    *
				FROM
				    {$wpdb->prefix}gf_addon_feed
				WHERE
				    addon_slug = 'gfconnectwise'
				    AND is_active = 1;
			",'')
		);
	}

	public function query_create_feed($form_id,$meta){
		global $wpdb;
		$wpdb->query(
			$wpdb->prepare(
				"
				INSERT INTO {$wpdb->prefix}gf_addon_feed(
					form_id,
					is_active,
					meta,
					addon_slug,
					feed_order
				)VALUES(
					%d,
					1,
					%s,
					'gravitywise',
					0
				);
",$form_id,$meta
			)
		);
	}

	public function query_disable_legacy($feed_id){
		global $wpdb;
		$wpdb->query(
			$wpdb->prepare(
				"UPDATE {$wpdb->prefix}gf_addon_feed
				SET is_active = 0
				WHERE id = %d;",$feed_id
			)
		);
	}



	public function get_new_action($id){
		return (object)[
			'id'=>$id,
			'type'=>'Create',
			'component'=>[],
			'request'=>[],
			'duplicatePolicy'=>'none'
		];
	}

	public function build_mt($id){
		return '{:' . $id . '}';
	}

	public function apply_migration( $legacy_json ) {
		$new_json = [
			'name'           => $legacy_json['name'],
			'CWFeedSettings' => [
				'name'       => $legacy_json['name'],
				'conditions' => [
					'active'      => false,
					'conjunction' => 'ANY',
					'statements'  => [
						[
							'property' => 'Id',
							'operator' => '',
							'value'    => ''
						]
					]
				],
				'actions'    => []
			]
		];
		if ( $legacy_json['create_company'] == 1 ) {
			$action = $this->get_new_action(1);
			$action->component = [
				'name'=>'Company',
				'endpoint'=>'/company/companies'
			];
			$action->request['name'] = $this->build_mt($legacy_json["company_standard_fields_CompanyName"]);
			$action->request['addressLine1'] = $this->build_mt($legacy_json['company_standard_fields_AddressLine1']);
			foreach ($legacy_json['company_custom_fields'] as $field){
				if($field['key']!="Choose a Field"){
					$action->request[lcfirst($field['key'])] = $this->build_mt($field['value']);
				}
			}
			if($legacy_json['company_territory_select']!=''){
				$action->request['territory'] = ['id'=>$legacy_json['company_territory_select']];
			}
			if($legacy_json['company_market_select']!=''){
				$action->request['market'] = ['id'=>$legacy_json['company_market_select']];
			}
			if($legacy_json['company_type_select']!=''){
				$action->request['type'] = ['id'=>$legacy_json['company_type_select']];
			}
			if($legacy_json['company_status_select']!=''){
				$action->request['status'] = ['id'=>$legacy_json['company_status_select']];
			}
			array_push($new_json['CWFeedSettings']['actions'],$action);
		}

		if ( $legacy_json['create_contact'] == 1 ) {
			$action = $this->get_new_action(2);
			$action->component = [
				'name'=>'Contact',
				'endpoint'=>'/company/contacts'
			];
			$action->request['firstName'] = $this->build_mt($legacy_json["contact_standard_fields_FirstName"]);
			foreach ($legacy_json['contact_custom_fields'] as $field){
				$action->request[lcfirst($field['key'])] = $this->build_mt($field['value']);
			}
			if($legacy_json['contact_relationship_select']!=''){
				$action->request['relationship'] = ['id'=>$legacy_json['contact_relationship_select']];
			}
			if($legacy_json['contact_type_select']!=''){
				$action->request['type'] = ['id'=>$legacy_json['contact_type_select']];
			}


			//Account for created company
			if($legacy_json['create_company'] == 1){
				$action->request['company'] = ['id'=>'{Previously Created Company:<1.id}'];
			}
			
			array_push($new_json['CWFeedSettings']['actions'],$action);
		}

		if ( $legacy_json['create_opportunity'] == 1 ) {
			$action = $this->get_new_action(3);
			$action->component = [
				'name'=>'Opportunity',
				'endpoint'=>'/sales/opportunities'
			];
			$action->request['name'] = $this->build_mt($legacy_json["opportunity_name"]);
			$action->request['primarySalesRep'] = ['name'=>$legacy_json['opportunity_sales_rep_select']];
			$action->request['notes'] = $this->build_mt($legacy_json["opportunity_description"]);

			foreach ($legacy_json['opportunity_custom_fields'] as $field){
				$action->request[lcfirst($field['key'])] = $this->build_mt($field['value']);
			}

			if($legacy_json['opportunity_stage_select']!=''){
				$action->request['stage'] = ['id'=>$legacy_json['opportunity_stage_select']];
			}
			if($legacy_json['opportunity_rating_select']!=''){
				$action->request['rating'] = ['id'=>$legacy_json['opportunity_rating_select']];
			}
			if($legacy_json['opportunity_close_probability_select']!=''){
				$action->request['probability'] = ['id'=>$legacy_json['opportunity_close_probability_select']];
			}
			if($legacy_json['opportunity_status_select']!=''){
				$action->request['status'] = ['id'=>$legacy_json['opportunity_status_select']];
			}
			if($legacy_json['opportunity_type_select']!=''){
				$action->request['status'] = ['name'=>$legacy_json['opportunity_type_select']];
			}
			if($legacy_json['opportunity_location_select']!=''){
				$action->request['location'] = ['id'=>$legacy_json['opportunity_location_select']];
			}
			if($legacy_json['opportunity_marketing_campaign_select']!=''){
				$action->request['campaign'] = ['id'=>$legacy_json['opportunity_marketing_campaign_select']];
			}


			$lookback_index = 1;
			//Account for created company
			if($legacy_json['create_company'] == 1){
				$action->request['company'] = ['id'=>'{Previously Created Company:<1.id}'];
				$lookback_index++;
			}
			//Account for created contact
			if($legacy_json['create_contact'] == 1){
				$action->request['contact'] = ['id'=>'{Previously Created Contact:<'.$lookback_index.'.id}'];
			}



			array_push($new_json['CWFeedSettings']['actions'],$action);
		}

		if ( $legacy_json['create_ticket'] == 1 ) {
			$action = $this->get_new_action(4);
			$action->component = [
				'name'=>'Ticket',
				'endpoint'=>'/service/tickets'
			];
			$action->request['summary'] =$legacy_json["ticket_summary"];
			$action->request['initialDescription'] = $legacy_json['ticket_detail_description'];

			foreach ($legacy_json['ticket_custom_fields'] as $field){
				$action->request[lcfirst($field['key'])] = $this->build_mt($field['value']);
			}

			$lookback_index = 1;
			//Account for created company
			if($legacy_json['create_company'] == 1){
				$action->request['company'] = ['id'=>'{Previously Created Company:<1.id}'];
				$lookback_index++;
			}
			//Account for created contact
			if($legacy_json['create_contact'] == 1){
				$action->request['contact'] = ['id'=>'{Previously Created Contact:<'.$lookback_index.'.id}'];
				$lookback_index++;
			}
			//Account for created opportunity
			if($legacy_json['create_opportunity'] == 1){
				$action->request['opportunity'] = ['id'=>'{Previously Created Opportunity:<'.$lookback_index.'.id}'];
			}
			array_push($new_json['CWFeedSettings']['actions'],$action);
		}

		if ( $legacy_json['create_activity'] == 1 ) {
			$action = $this->get_new_action(5);
			$action->component = [
				'name'=>'Activity',
				'endpoint'=>'/sales/activities'
			];
			$action->request['name'] =$legacy_json["activity_subject"];
			$action->request['assignTo'] = ['name'=>$legacy_json["activity_assign_to"]];
			$action->request['notes'] =$legacy_json["activity_subject"];

			foreach ($legacy_json['activity_custom_fields'] as $field){
				$action->request[lcfirst($field['key'])] = $this->build_mt($field['value']);
			}

			if($legacy_json['activity_status_select']!=''){
				$action->request['status'] = ['id'=>$legacy_json['activity_status_select']];
			}
			if($legacy_json['activity_type_select']!=''){
				$action->request['type'] = ['id'=>$legacy_json['activity_type_select']];
			}
			if($legacy_json['activity_campaign_select']!=''){
				$action->request['campaign'] = ['id'=>$legacy_json['activity_campaign_select']];
			}

			$lookback_index = 1;
			//Account for created company
			if($legacy_json['create_company'] == 1){
				$action->request['company'] = ['id'=>'{Previously Created Company:<1.id}'];
				$lookback_index++;
			}
			//Account for created contact
			if($legacy_json['create_contact'] == 1){
				$action->request['contact'] = ['id'=>'{Previously Created Contact:<'.$lookback_index.'.id}'];
				$lookback_index++;
			}
			//Account for created opportunity
			if($legacy_json['create_opportunity'] == 1){
				$action->request['opportunity'] = ['id'=>'{Previously Created Opportunity:<'.$lookback_index.'.id}'];
				$lookback_index++;
			}
			//Account for created ticket
			if($legacy_json['create_ticket'] == 1){
				$action->request['ticket'] = ['id'=>'{Previously Created Ticket:<'.$lookback_index.'.id}'];
				$lookback_index++;
			}

			array_push($new_json['CWFeedSettings']['actions'],$action);
		}
		return $new_json;
	}

	public function run_migration($id){
		$legacy = $this->query_legacy_feeds();

			foreach ($legacy as $legacy_feed){
				if($legacy_feed->form_id==$id || $id==null){
					$new_feed = $this->apply_migration(json_decode($legacy_feed->meta,true));
					$this->query_create_feed($legacy_feed->form_id,json_encode($new_feed));
				}
				//$this->query_disable_legacy($newfeed->id);
			}

	}


}

