<?php
/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

const RR_OPTION = 'gravityformsaddon_gfconnectwise_lastroundrobin';
class bizz_MergeTags{

    public $form_data;
    public $action_responses;


    //Action respones is array of json strings
    public function __construct($form_data,$action_responses = [])
    {
        $this->form_data = $form_data;
        $this->action_responses = $action_responses;
    }

    public function setActionResponses($action_responses){
        $this->action_responses = $action_responses;
    }

    public function getActionResponses(){
        return $this->action_responses;
    }

    public function getFormData(){
        return $this->form_data;
    }



    public function replaceMergeTags($string)
    {
        preg_match_all('/%7B.*?%7D/', $string, $matches);
        $mt_array = [];
        foreach ($matches[0] as $key => $value) {
            array_push($mt_array, $this->getMergeTag($value));
        }
        foreach ($mt_array as $key => $value) {
            $string = preg_replace('/%7B.*?%7D/', $value, $string, 1);
        }

        return $string;
    }

    public function getMergeTag($merge_tag)
    {
        $merge_tag = urldecode($merge_tag);
        //NEW REGEX (?<=:)(<|cw\.|)([\da-zA-Z]+)\.{0,1}([\d\w.]*)
        preg_match('/(?<=:)(<|cw\.|)([\da-zA-Z]+)\.{0,1}([\d\w.]*)/', $merge_tag, $matches);
        $src=null;
        
        if($matches[1] == "<"){
            $src = $this->action_responses[intval($matches[2])-1];
        }else if($matches[1]=="cw."){
        	if($matches[2]=='salesTeam'){
        		return $this->salesTeam($matches[3]);
	        }
        } else{
            if(isset($this->form_data[$matches[2]])){
                $src = $this->form_data[$matches[2]]['value'];
            }else{
                return $this->form_data["$matches[2].$matches[3]"]['value']; 
            }
        }

        if ($matches[3] != "") {
            return $this->getMergeTagProperty($matches[2], $matches[3], $src);
        }

        return $this->getMergeTagField($matches[2],$src);
    }

    public function getMergeTagField($field, $src)
    {
        $value = urldecode($src);
        $value = preg_replace('/[\'\"]/', '', $value);
        return urlencode($value);
    }

    public function getMergeTagProperty($field, $property_path, $src)
    {
        if(isset($this->form_data["$field.$property_path"])){
            return $this->form_data["$field.$property_path"]['value'];
        }

        $json_value = json_decode($src, true);
        if ($json_value!='') {
            $path = explode('.', $property_path);
            foreach ($path as $key => $value) {
                $json_value = $json_value[$value];
            }
            return $json_value;
        }
    }


    public function salesTeam($args): string{
    	$args = explode('.',$args);
	    $teamId = ctype_digit($args[0]) ? intval($args[0]) : null;
	    if ($teamId === null)
	    {
		    return '';
	    }
	    $cw_api = new bizz_ConnectwiseClient();
	    $response = $cw_api->getCwData("/sales/salesTeams/$teamId/members",'fields=member');
		$members = [];
	    foreach ($response as $person){
			array_push($members,$person->member->id);
		}
	    if($args[1]==='next' || $args[1]==='nextOrExisting'){
	    	$prefix = $args[1]==='nextOrExisting'? '⌻'.$teamId.'⌻': '';
			$last_member = get_option(RR_OPTION,null);
			if($last_member == null){
				update_option(RR_OPTION,$members[0]);
				return $prefix . $members[0];
			}else{
				$found = false;
				foreach ($members as $member){
					if($found===true){
						update_option(RR_OPTION,$member);
						return $prefix . $member;
					}
					if($last_member == $member){
						$found = true;
					}
				}
				if($found===true){
					update_option(RR_OPTION,$members[0]);
					return $prefix . $members[0];
				}else{
					$res = array_rand($members);
					update_option(RR_OPTION,$res);
					return $prefix . $res;
				}
			}
	    }else if($args[1]==='random'){
			return array_rand($members);
	    }else{
	    	return '';
	    }

    }
}
