/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

jQuery(document).ready(function($){
    var getSections = document.querySelectorAll('.gaddon-section:not(.gaddon-first-section)');
    jQuery.each(getSections, (index, element) => {
        var img = document.createElement('img');
        img.src = storedFeedVariables.feedDeleteIcon();
        img.id = `img_${element.id}`;
        img.onclick = (e) => {
            e.preventDefault();
            DeleteFeedSection(e.target);
        };
        img.width = "12";
        jQuery(img).addClass('inline');

        element.firstElementChild.appendChild(img);
    });


    jQuery.each(document.getElementsByClassName('gaddon-bng_multi_select'), (index, element) => {
        jQuery(element).chosen({
                            single_backstroke_delete: false,
                            placeholder_text_multiple: "Select Fields to Return",
                            search_contains: true,
                            display_selected_options: false,
                            hide_results_on_select: false})
                        .trigger("chosen:updated");
    });

    jQuery( '.cw-lookup-support' ).each( function() {
        new CwLookupFieldValueObj( form, jQuery( this ) );
    } );


    // MicroModal.init({
    //     awaitCloseAnimation: true, // set to false, to remove close animation
    //     onClose: function(modal) {
    //         jQuery(modal).find('li').remove();
    //     }
    // });
});

var storedFeedVariables = storedFeedVariables || ( function() {
    var _args = {}; // private

    return {
        init : function(Args) {
            _args = Args;
        },
        feedDeleteIcon : function() {
            return _args.FeedDeleteIcon;
        },
    };
} () );

/**
 * ConnectWise lookup value tag object
 * @param {array} form
 * @param {HTMLInputElement} element
 */
var CwLookupFieldValueObj = function( form, element ) {
	var self      = this;
		self.form = form;
		self.elem = element;

	/**
	* Initialize
	*/
	self.init = function() {
		if ( self.elem.data( 'cwLookupFieldValue' ) ) {
			return;
		}

		self.mergeTagList      = jQuery( '<ul id="cw_lookup_field_list" class=""></ul>' );
		self.mergeTagListHover = false;

		self.bindKeyDown();

		self.addMergeTagIcon();

		self.mergeTagList.hover(
			function() {
				self.mergeTagListHover = true;
			},
			function(){
				self.mergeTagListHover = false;
			}
		);

		jQuery( 'body' ).mouseup( function() {
			if( ! self.mergeTagListHover ) {
				self.mergeTagList.hide();
			}
		} );

        self.elem.data( 'cwLookupFieldValue', self );
	};

	/**
	* Destroy a merge tag object.
	*/
	self.destroy = function( element ) {
		// Get element.
		element = self.elem ? self.elem : element;

		element.next( '.cw-lookup-field-value' ).remove();
		element.off( 'keydown.gravityforms' );
		element.autocomplete( 'destroy' );
		element.data( 'cwLookupFieldValue', null );
    };

	/**
	* Bind keydown event to element.
	*/
	self.bindKeyDown = function() {
		self.elem.on( 'keydown.gravityforms', function( event ) {

			if ( event.keyCode === jQuery.ui.keyCode.TAB ) {
				event.preventDefault();
			}

		} );
	}

	/**
	* Add merge tag drop down icon next to element.
	*/
	self.addMergeTagIcon = function() {
		var inputType       = self.elem.is( 'input' ) ? 'input' : 'textarea',
            positionClass   = self.getClassProperty( self.elem, 'position' ),
            elementId       = self.elem.prop('id'),
            modalTitle      = self.elem.parent().prev().text().replace('*', '');

        self.mergeTagIcon  = jQuery( `<button id="trigger-button-${elementId}" type="button" data-micromodal-trigger="modal-${elementId}" class="cw-lookup-field-value ${positionClass}  ${inputType} "><a class="launch-modal tooltip-lookup-field" title="ConnectWise Lookup Field Value allows you to find a value for the associating field."></a></button>
        <div id="modal-${elementId}" class="feed-modal micromodal-slide" aria-hidden="true">
            <div class="modal__overlay" tabindex="-1" data-micromodal-close>
                <div id="modal-container-${elementId}" class="modal__container" role="dialog" aria-modal="true" aria-labelledby="modal-title" >
                    <header class="modal__header">
                        <h2 id="modal-title-${elementId}"  class="modal__title">
                            LookUp ConnectWise Component Value - ${modalTitle}
                        </h2>
                        <button type="button" class="modal__close" aria-label="Close modal" data-micromodal-close></button>
                    </header>
                    <div id="modal-content-content-${elementId}" class="modal-content-content">
                        <div id="modal-content-${elementId}" class="modal__content">
                            <ul>
                            </ul>
                        </div>
                        <!--footer id="modal-footer-${elementId}" class="modal__footer">
                            <button type="button" id="modal-save-${elementId}" class="modal__btn" data-micromodal-close aria-label="Close and save value">Close and Save</button>
                        </footer-->
                    </div>
                </div>
            </div>
        </div>` );


        // self.mergeTagIcon.last().on('click', async (e) => { await RetrieveComponentPropertyValue(e.currentTarget); });
        self.mergeTagIcon.first().on('click', self.retrieveComponentPropertyValue);

        // self.mergeTagIcon.find(`#modal-content-${elementId} li`).on('click', self.bindMergeTagListClick);
        self.mergeTagIcon.data( 'targetElement', self.elem.attr( 'id' ) );

		if ( self.getClassProperty( self.elem, 'manual_position' ) ) {

			var manualClass = '.mt-' + self.elem.attr('id');

			jQuery( manualClass ).append( self.mergeTagIcon );

		} else {

			self.elem.after( self.mergeTagIcon );

		}

		self.mergeTagIcon.find( '.tooltip-lookup-field' ).tooltip( {
			show:    { delay:1250 },
			content: function () { return jQuery( this ).prop( 'title' ); }
		} );
	}

	/**
	* Bind click event when selecting merge tag from drop down menu.
	*/
	self.bindMergeTagListClick = function( event ) {
        MicroModal.close(`modal-${self.elem.prop('id')}`);

		var value = jQuery( event.target ).attr('value');
        var input = self.getTargetElement();

		if( self.isWpEditor( input ) ) {
			InsertEditorVariable( input.attr('id'), value );
		} else {
			InsertVariable( input.attr('id'), null, value );
		}

        input.trigger( 'input' ).trigger( 'propertychange' );
        jQuery(event.target.parentElement).find('li').remove()
    }

    self.retrieveComponentPropertyValue = async function (element) {
        var elementId = self.elem.prop('id');
        var modalContent = document.getElementById(`modal-content-${elementId}`);
        var spinner = `#gform_ajax_spinner_${self.form.id}`;

        if (jQuery(spinner).length > 0) {
            jQuery(spinner).remove();
        }

        var spinnerTarget = gform.applyFilters('gform_spinner_target_elem', jQuery(modalContent), self.form.id);
        spinnerTarget.before('<img id="gform_ajax_spinner_' + self.form.id + '"  class="gform_ajax_spinner" src="' + storedPhpVariables.spinnerPath() + '" alt="" />');

        var componentIndex = RetrieveComponentIndex(elementId);
        var selectedComponents = document.getElementById('feed_selected_connectwise_components').value.split(',');
        var componentToUse = selectedComponents[componentIndex];

        var args = {component: componentToUse, elementId: elementId, version: storedPhpVariables.cwApiVersion(), operation: 'getLookupValueForFeed'};

        await AjaxCall(args).then( (data) => {
            jQuery(spinner).show();
            var ul = jQuery(modalContent).find('ul');

            if (!data.length) {
                var listItemStr = `<li id="NoDatFound" class="modal__content__li__bottom">Sorry, no data found.</li>`;
                var listItem = jQuery( listItemStr ) ;

                ul.append(listItem);
            }

            for (obj in data) {
                var value = data[obj].value;
                var text = data[obj].text;

                var listItemStr = `<li id="${value}" value="${value} {${text}}" class="modal__content__li__bottom">${text}</li>`;
                var listItem = jQuery( listItemStr ) ;

                listItem.on('click', self.bindMergeTagListClick);
                ul.append(listItem);
            }

            jQuery(spinner).hide();
        }, (error) => {
            alert(`Error (${error.status}): ${error.statusText}`);
            MicroModal.close(`modal-${self.elem.prop('id')}`);
        });
    }

	self.getClassProperty = function( elem, property ) {
		var elem	 = jQuery( elem ),
			classStr = elem.attr( 'class' );

		if ( ! classStr ) {
			return '';
		}

		var classes = classStr.split( ' ' );

		// Loop through CSS classes.
		for ( i in classes ) {
			// If property does not exist, skip it.
			if ( ! classes.hasOwnProperty( i ) ) {
				continue;
			}

			// Split class into pieces.
			var pieces = classes[i].split('-');

			if ( pieces[0] != 'mt' || pieces[1] != property ) {
				continue;
			}

			if ( pieces.length > 3 ) {
				delete pieces[0];
				delete pieces[1];
				return pieces;
			} else if( pieces.length == 2 ) {
				// If only a property is passed, assume we are looking for boolean, return true.
				return true;
			} else {
				// Otherwise, return the value.
				return pieces[2];
			}
		}
		return '';
	};

	self.getTargetElement = function(  ) {
		var selector = self.mergeTagIcon.data('targetElement');

		return jQuery( '#' + selector.replace(/[!"#$%&'()*+,.\/:;<=>?@[\\\]^`{|}~]/g, "\\$&") );
	}

	self.isWpEditor = function( mergeTagIcon ) {
		// Get merge tag icon element.
		var mergeTagIcon = jQuery( mergeTagIcon );

		return this.getClassProperty( mergeTagIcon, 'wp_editor' ) == true;
	};

	// If element is defined, initialize.
	if ( self.elem ) {
		self.init();
	}
};

/**
 * Toggles the ConnectWise display view.
 * Tells the client whether to show all or limited components
 */
async function ToggleFeedConnectWiseEndpoints(displayAll) {
    await FeedCwComponents(displayAll).then(
        /*(val) => {
            RetrieveRequiredProperties(val);            
            ResetAdvancedFilters();
        }*/
    );
    spinner.hide();
}

/**
 * Retrieves ConnectWise components
 * @param {bool} noFilter  - indicates whether to use a filter or not
 */
async function FeedCwComponents(noFilter = false) {
    var selectTag = document.getElementById('selected_feed_connectwise_components');

    var args = {version: storedPhpVariables.cwApiVersion(), filter: noFilter, apiRequestType: 'post', operation: 'getCWComponents'};
    return await AjaxCall(args).then((data) => {
        selectTag.options.length = 0;
        jQuery.each(data, function(i, d) {
            selectTag.options.add(new Option(i, d));
        });

        return selectTag.value;
    });
}

function InsertCwComponent(selectedComponent) {
    var selected = document.getElementById('feed_selected_connectwise_components');

    selected.value += `${selectedComponent},`;
    jQuery('#feed_selected_connectwise_components').parents('form').submit();
}

function DeleteFeedSection(element) {
    jQuery('#gform-settings').css({"cursor": "wait",
        "pointer-events": "none"
    });

    var selected = document.getElementById('feed_selected_connectwise_components');
    var selectedIndex = RetrieveComponentIndex(element.id);
    var selectedArray = selected.value.split(',');

    delete selectedArray[selectedIndex];
    element.parentElement.parentElement.remove();

    selectedArray = selectedArray.filter(Boolean);
    selected.value = `${selectedArray.join(',')},`;
    jQuery('#feed_selected_connectwise_components').parents('form').submit();
}