/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

/**
 * Namespace to be used globally to store necessary data
 */
var storedPhpVariables = storedPhpVariables || ( function() {
    var _args = {}; // private

    return {
        init : function(Args) {
            _args = Args;
        },
        cwApiVersion : function() {
            return _args.Version;
        },
        helperDir : function() {
            return _args.HelperDir;
        },
        mergeTagRefs : function() {
            return _args.MergeTagRefs;
        },
        spinnerPath : function() {
            return _args.SpinnerPath;
        },
        spinnerName : function() {
            return _args.Spinner;
        },
        getUrlPath : function() {
            return _args.GetUrlPath;
        },
        getClearLogPhp : function() {
            return _args.GetClearLogPhp;
        }
    };
} () );

var inputTimer;
jQuery(document).ready(function($) {

    InitialUpdate();
    

    jQuery('[name^="input_"]').on('input',(d)=>{
        window.clearTimeout(inputTimer);
        inputTimer = setTimeout(()=>{
            UpdateChildren(d);
        },1500);
    });

    jQuery('[name^="input_"]').on('change',(d)=>{
        UpdateChildren(d);
    });
 });


function UpdateChildren(d){
    window.clearTimeout(inputTimer);
    var id = parseInt(d.currentTarget.name.match(/[0-9]+/)[0]);
    cwHelperJs.notifyMergeTagChange(id,d.currentTarget.value).then(()=>{
        cwField.UpdateChildren(id);
    });
}

async function InitialUpdate(){
    // console.log(jQuery('[name^="input_"]'));
    var inputs = jQuery('[name^="input_"]')
    for (let index = 0; index < inputs.length; index++) {
        const element = inputs[index];
        var id = element.name.match(/[0-9]+/)[0];
        await cwHelperJs.notifyMergeTagChange(id,element.value);
        
    }
    
    cwField.AppList.forEach(element => {
        element.search(true);
    });
}


/*
jQuery(document).on('gform_load_field_settings', function(event, field) {
    if(field.type.startsWith('cw_')){
        if(basicSettingsApp!=undefined){
            basicSettingsApp.getField(field.id, ()=>{
                basicSettingsApp.getConnectwiseComponents();
                basicSettingsApp.getRequiredProps();
            });
            advancedSettingsApp.getField(field.id, ()=>{
                advancedSettingsApp.getProperties();
            });
        }
        if(field.type == "cw_table"){
            advancedSettingsApp.isTable=true;
            advancedSettingsApp.settings.tableSettings.active=true;
        }else{
            advancedSettingsApp.isTable=false;
            advancedSettingsApp.settings.tableSettings.active=false;
        }
    }else{
        if(basicSettingsApp!=undefined){
            basicSettingsApp.selected = -1;
            advancedSettingsApp.selected = -1;
        }
    }
});

 */