/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

var filterEncoder = {
    encode: function(data) {
        var res = '';
        res += `pageSize=${data.limitResults}`
        res += this.encodeParameter('conditions',data,this.conditionString);
        res += this.encodeParameter('childConditions',data,this.conditionString);
        res += this.encodeParameter('customFieldConditions',data,this.conditionString);
        res += this.encodeParameter('orderBy',data,this.orderByString);
        res += this.encodeParameter('fields',data,this.fieldsString);
        return res;
    },

    encodeParameter: function(parameter, data, stringFunction){
        if(data[parameter]['active']==true){
            
            return `&${parameter}=${encodeURIComponent(stringFunction(data[parameter]))}`;
        }
        return '';
    },

    conditionString: function(data) {
        var res = [];
        //Need to know property type to work properly
        data.statements.forEach(element => {
            var p = JSON.parse(element.property);
            if(p.type == 'string'){
                res.push(`${p.name.replace(".","/")} ${element.operator} "${element.value}"`);
            }else{
                res.push(`${p.name.replace(".","/")} ${element.operator} ${element.value}`);
            }

        });
        return res.join(data.conjunction=="ANY"?" OR ":" AND ");
    },

    orderByString: function(data){
        var res="";
        data.statements.forEach(element=>{
            res+=`${element.property} ${element.order} `;
        });
        return res;
    },

    fieldsString: function(data) {
        return data.statements.join(',');
    } 
}
