/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

(function() {
    window.generateUrl = async function() {
        if (document.getElementById('cw_site').value == '' || document.getElementById('company_id').value == '') {
            alert('Please enter values for Company ID and ConnectWise Site.');
        }
        else {
            let url;
            if (document.getElementById('cw_site').value == 'na.myconnectwise.net') {
                //this is a hosted environment, so we have to prepend api- to the url
                url = "https://api-" + document.getElementById('cw_site').value;
            }
            else {
                //this is an external environment, use that url
                url = "https://" + document.getElementById('cw_site').value;
            }
            url += "/login/companyinfo/" + document.getElementById('company_id').value;
            document.getElementById('connectError').style.display = "none";
            document.getElementById('connectSuccessful').style.display = "none";

            await fetch(url)
                .then(response => {
                    console.log(response);
                    if (response.status === 200) {
                        document.getElementById('connectSuccessful').style.display = "block";
                        document.getElementById('connectError').style.display = "none";
                    } else {
                        document.getElementById('connectSuccessful').style.display = "none";
                        document.getElementById('connectError').style.display = "block";
                    }
                }).catch(error => {
                    console.log(error);
                    document.getElementById('connectSuccessful').style.display = "none";
                    document.getElementById('connectError').style.display = "block";
            });


        }
    }
})();


(function() {
    window.clearLogFile = function() {
        var url = "<?php echo $plugin_dir; ?>";
        var urlExpanded = url + "?valid=" + Math.round((new Date()).getTime() / 1000) + "&path=<?php echo urlencode(plugin_dir_path( dirname(__FILE__ ))); ?>"

        var getJSON = function(url, successHandler, errorHandler) {
            var xhr = typeof XMLHttpRequest != 'undefined'
                ? new XMLHttpRequest()
                : new ActiveXObject('Microsoft.XMLHTTP');
            xhr.open('POST', url, true);
            xhr.responseType = 'text';
            xhr.onreadystatechange = function() {
                var status;
                var data;
                // https://xhr.spec.whatwg.org/#dom-xmlhttprequest-readystate
                if (xhr.readyState == 4) {
                    status = xhr.status;
                    if (status == 200) {
                        if (xhr.responsText === 'Fail') {
                            errorHandler && errorHandler(xhr.response);
                        }
                        else {
                            successHandler && successHandler(xhr.response);
                        }
                    } else {
                        errorHandler && errorHandler(status);
                    }
                }
            };
            xhr.send();
        }
        var data;

        getJSON(urlExpanded, function(data) {
            //should be complete, file should be cleared
            alert('The contents of the log file were cleared successfully.');
        }, function(status) {
            console.log('There was an error.');
        });
    }
})();