<!--************************************************************************************************-->
<!-- © Copyright 2021, BizZToolz-->
<!-- Use of this code is permitted under the terms of the GNU Lesser General Public License-->
<!-- https://www.fsf.org/-->
<!--************************************************************************************************-->


<div id="basicSettingsVue">
    <li class="connectwise_components_standard_settings field_setting" v-if="selected!=-1">
        <!-- Components -->
        <div id="gform_pagination_settings_tab_1">
			<ul class="gforms_form_settings">
		<?php
        /**
         * Inserts additional content within the General field settings
         *
         * Note: This action fires multiple times.  Use the first parameter to determine positioning on the list.
         *
         * @param int 0        The placement of the action being fired
         * @param int $form_id The current form ID
         */
		do_action( 'gform_field_standard_settings', 0, $form_id );
		?>
		<li class="label_setting field_setting">
			<label for="field_label" class="section_label">
				<?php esc_html_e( 'ConnectWise Components', 'gravityforms' ); ?>
				<?php gform_tooltip( 'cw_component_properties' ) ?>
				<?php gform_tooltip( 'cw_label_html' ) ?>
			</label>
			<input type="text" id="field_label" class="fieldwidth-3" size="35" />
		</li>
        </ul>
            <input type="checkbox" v-model="settings.showAllComponents" @change="getConnectwiseComponents(settings.showAllComponents)"/>
            <label class="inline" >
                Show Advanced Components
                <?php gform_tooltip( 'show_all_connectwise_components' ) ?>
            </label>
        </div>
        <div style="display: flex;">
            <select v-model="settings.cwComponentField" style="width: 375px;" @change="componentChanged()">
                <option v-for="i in cwComponents" :value="i">{{i.name}}</option>
            </select>
            <div v-show="gettingComponents" class="loader"></div>
        </div>

        <!-- Required Properties -->
        <label class="section_label" v-show="settings.requiredProperties>0">
            Required Properties
		    <?php gform_tooltip( 'cw_required_props' ) ?>
        </label>
        <div v-for="prop in settings.requiredProperties" class="row" style="vertical-align: middle;">
            {{prop.propertyName}}
            <merge-tag :value="prop.propertyField" @input="prop.propertyField=$event" :field="selected"></merge-tag>
        </div>
    </li>
</div>

<!-- Vue Script -->
<script type="text/javascript">
    
    var basicSettingsApp = new Vue({
        el: '#basicSettingsVue',
        mixins: [CwMixin],
        data:{
            lastIndex: 0,
            cwComponents: [],
            gettingComponents: true
        },
        
        methods:{
            getConnectwiseComponents: function(showAll){
                this.loading = true;
                this.gettingComponents = true;
                cwHelperJs.retrieveConnectwiseComponents(showAll!==undefined?showAll:this.settings.showAllComponents)
                    .then((data)=>{
                        this.cwComponents=data;
                        this.loading = false;
                        this.gettingComponents =false;
                    });  
            },
            componentChanged: function(){


                this.loading = true;
                advancedSettingsApp.getProperties();
                this.getRequiredProps();
            },
            getRequiredProps: function(){
                this.lastIndex++;
                var indexAtRequest = this.lastIndex;

                console.log(this.settings.cwComponentField);
                if(this.settings.cwComponentField==undefined){return;}
                if(this.settings.cwComponentField.endpoint.match(/\{\w+\}/g)){                    
                    cwHelperJs.retrieveRequiredProperties(this.settings.cwComponentField,this.settings.requiredProperties)
                        .then((data)=>{
                            if(indexAtRequest==this.lastIndex){
                                this.settings.requiredProperties = data;
                                this.loading = false;
                            }
                        });
                }else{
                    this.settings.requiredProperties=[];
                    this.loading = false;
                }
                
            }
        },
        updated: function(){
            gform_initialize_tooltips();
        }
    });

</script>



