/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

//This component is a mess because it is built around a dependency we can't change.
//Consider contributing to open source to clean this code up
//https://vue-multiselect.js.org/
Vue.component('merge-tag',{
    props: ['value','type','field'],
    data: function(){
        return{
            options: [],
            custom: true
        };
    },
    
    //vue-multiselect@2.1.0:1 [Vue-Multiselect warn]: ClearOnSelect and Multiple props can’t be both set to false.
    //This warning seems to be dead code because not only can they both be false, but they are entirely independent from each other.
    //Don't listen to it.
    template: `
        <vue-multiselect 
            :value="value"
            :options="options"
            :preserveSearch="true"
            group-values="props"
            group-label="label"
            label="property"
            :group-select="false"
            @search-change="typing"
            @input="input"
            @select="select"
            ref="searchDetails"
            @open="open"
            :deselectLabel="'Selected'	"
            :selectedLabel="'Select to edit'"
            :closeOnSelect="false"
            :clearOnSelect="false"
            :optionHeight="30"
            >
            <template slot="singleLabel" slot-scope="{ option }">{{option.tag}}
            </template>
    
            <template slot="caret">
            <div></div>
            </template>
            </vue-multiselect>
    `
    ,methods:{
        //This sets the selected option to whatever you type in.
        //Called when keyboard is pressed.
        typing: function(s,i){
            if(0 in this.options){
                this.options[0].props[0].property = s;
                this.options[0].props[0].tag = s;
                this.$emit('input',this.options[0].props[0]);
            }
        },
        //Called when this.value is changed.
        input: function(i){
            // console.log(this.custom);
            if(this.options[0]==undefined){
                this.$refs.searchDetails.updateSearch(this.options[0].props[0].property);

            }
            this.options[0].props[0].property =this.options[0].props[0].tag;
            this.$emit('input',this.options[0].props[0]);
            this.$refs.searchDetails.updateSearch(this.options[0].props[0].property);

        },
        //Called when an option is selected.
        select: function(selected,id){
            
                this.custom = false;
                this.options[0].props[0] = Object.assign({},selected);
                this.$emit('input',this.options[0].props[0]);
                this.$refs.searchDetails.pointer=0;
                this.$refs.searchDetails.updateSearch(this.options[0].props[0].property);


        },
        //TODO, a method should be extracted to handle loading independently.
        //TODO, it should exclude the selected merge tag.
        //TODO, call extracted method when a new property is selected.
        open: function(i){
            
            var defaultOption ={label:"Custom Tag"};
            if(this.value.props !=undefined){
                defaultOption.props = this.value;
            }else{
                defaultOption.props = [{property: "", tag: "", label: ""}];
            }
            var b = gfHelper.getMergetagOptions(this.field);
            b.unshift(defaultOption);
            this.options = b;
        }

        
        
    },
    created: function(){
        this.$emit('creation');
    },
    updated: function(){
        this.$refs.searchDetails.updateSearch(this.value.tag);        
    }
});