<!--************************************************************************************************-->
<!-- © Copyright 2021, BizZToolz-->
<!-- Use of this code is permitted under the terms of the GNU Lesser General Public License-->
<!-- https://www.fsf.org/-->
<!--************************************************************************************************-->


<div id="field_<?=$field->id?>">
    <div v-for="(item, index) in entryAsArray">
        <table class="entryTable">
            <tr><th colspan="2">Item {{index + 1}}</th></tr>
            <tr v-for="(value,name) in item">
                <td><strong>{{name}}:</strong></td>
                <td>{{value}}</td>
            </tr>
            <tr v-for="(value,name) in tryGetExtraData(index)">
                <td><strong>{{name}}:</strong></td>
                <td>{{value}}</td>
            </tr>
        <tfoot  v-if="!(index in extraData) && item['id']!=undefined">
            <tr>
            <th colspan="2">
            
            <div style="display: flex;">
                <button @click="getFullData(item,index)" class="button button-secondary" type="button">Load full data from ConnectWise</button>            
                <div v-show="loading.includes(index)" class="loader"></div>
            </div>
            </td>
            </tr>
        </tfoot>
        </table>
    </div>
 
</div>

<script type="text/javascript">
    var entryApp<?=$field->id?> = new Vue({
        el: '#field_<?=$field->id?>',
        data:{
            cwSettings: <?=json_encode($field->cwSettings)?>,
            entry: <?=json_encode(preg_replace("/\&quot\;/","\\\"",$value));?>,
            extraData: {},
            loading: []
        },
        computed:{
            entryAsArray: function(){
                // console.log(this.entry);
                var stripSlash = this.entry.replace(/\\/g,'');
                json = stripSlash.replace(/"(?={)|(?<=})"/g,'');
                // console.log(json);
                var parsed =  JSON.parse(json);
                if(!Array.isArray(parsed)){
                    return [parsed];
                }else{
                    return parsed;
                }
            },
        },
        methods:{
            retrieveDatabaseLookupAdmin: async function(endpoint, id){
                var data = await fetch(`/wp-content/plugins/gravitywise/includes/cw-connector/api//query/admin-query.php?endpoint=${endpoint}&id=${id}`)
                if(data == undefined){
                    return;
                }
                return data.json();
            },
            getFullData: function(item,index){
                this.loading.push(index);
                this.retrieveDatabaseLookupAdmin(this.cwSettings.cwComponentField.endpoint,item['id']).then((data)=>{
                    this.extraData[index] = data;
                    delete this.extraData[index][0]['_info'];
                    
                    for (const [key, value] of Object.entries(this.extraData[index][0])) {
                        for (const [k, v] of Object.entries(item)) {
                            if(k===key){
                                delete this.extraData[index][0][key];
                            }
                        }
                        if(typeof value === 'object'){
                            this.extraData[index][0][key] = value.name;
                        }


                    }

                    this.$forceUpdate();
                });
            },
            tryGetExtraData:function (index){
                if(index in this.extraData){
                    return this.extraData[index][0]
                }else{
                    return [];
                }
            }
        }
    });        

    
    

</script>