/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

Vue.component('array-display', {
    props: ['array','label'],
    computed: {
        ...Vuex.mapGetters(['SelectedAction']),
    },
    methods:{
        Duplicate: function (index){
            this.array.push({...this.array[index]});
        },
        Remove: function (index){
            this.array.splice(index,1);
            if(this.array.length===0){
                this.$emit('closed');
            }
        }
    },
    template: `
        <div class="fb_object_container">
            {{label[0].toUpperCase() + label.substring(1)}}
            <div v-for="(item,i) in array">
                <object-display array="true" close="true" :label="label.slice(0,-1)" @duplicate="Duplicate(i)" @closed="Remove(i)" :object="item"></object-display>
            </div>
        </div>
    `
});