/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

Vue.component('field-entry', {
    props: ['label','value','close'],
    data: function (){
        return{
            collapsed: false,
        }
    },
    computed: {
        val:{
            get(){
                return this.value;
            },
            set(newVal){
                this.$emit('input',newVal);
                this.$forceUpdate();
            }
        }
    },
    methods:{

    },
    template: `
        <div class="fb_flex">
            <p>{{label[0].toUpperCase() + label.substring(1)}}</p>
            <input v-if="label!='notes'" v-model="val" type="text">
            <textarea v-else v-model="val"></textarea>
            <merge-tag-u @chosen="val+=$event" ></merge-tag-u>
            <button v-if="close" @click="$emit('closed')" class="button gform-button fb_close_button" type="button"><i class="fa fa-close"></i></button>
        </div>
    `
});