/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

Vue.component('item-lookup', {
    props: ['component','refcomponent'],
    data: function (){
        return{
            records: [],
            show: false,
            searchstr: "",
            loading: false
        }
    },
    computed: {
        ...Vuex.mapState(['Components'])
    },
    methods:{
        search: async function (){
            this.loading = true;
            var url = '/../wp-content/plugins/gravitywise/includes/api/feed-builder/get-results.php';
            url += '?component='+ this.component;
            url += '&refcomponent=' + this.refcomponent;
            url += '&search=' + this.searchstr;
            var req = await fetch(url);
            this.records = await req.json();
            this.$forceUpdate();
            this.loading = false;
        },
        showModal: function (){
            this.show=true
            this.search();
        }
    },
    created: function (){
    },
    template: `
    <div class="fb_action_modal" v-if="show">
        <div class="fb_modal_header">
                <h1>
                    Lookup {{refcomponent}}
                </h1>
                <h1>
                    <a style="cursor: pointer">
                        <i class="fa fa-close" @click="show=false"></i>
                    </a>
                </h1> 
        </div>
            <div class="fb_flex">
                <p>Search</p>
                <input type="text" v-model="searchstr">
                <button type="button" @click="search"><i class="fa fa-search"></i></button>
            </div>
            <div v-show="!loading" class="fb_limited_Scroll">
                <ul>
                    <li v-for="item in records">
                        <a @click="$emit('selected', item);show=false" style="cursor: pointer;">{{item.name ?? item.identifier}}</a>
                    </li> 
                </ul>
            </div>
            <div v-show="loading" class="loader"></div>
        </div>
    </div>
    `
});
