/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

Vue.component('object-display', {
    props: ['label','object','array','close'],
    data: function (){
        return{
            collapsed: true
        }
    },
    computed: {
        ...Vuex.mapGetters(['SelectedAction'])
    },
    methods:{
        OpenLookup: function (){

        },
        SelectObject: function (item){
            Object.keys(this.object).forEach( key=>{
                this.object[key]=item[key];
            });
            this.$forceUpdate();
        }
    },
    template: `
        <div class="fb_object_container">
            <div class="fb_flex">
                <div class="fr_caret_container"  @click="collapsed=!collapsed">
                   <img class="fr_caret" :class="{expanded: !collapsed}" src="/wp-content/plugins/gravitywise/public/images/caret.png"/>
                </div>
                <a style="flex-grow: 1" @click="collapsed=!collapsed">{{label[0].toUpperCase() + label.substring(1)}}</a>
                <button v-if="array" style="margin-right: 0.9rem" @click="$emit('duplicate')" class="button gform-button fb_close_button" type="button"><i class="fa fa-plus"></i></button>
                <button v-if="close" style="margin-right: 0.4rem" @click="$refs.lookup.showModal()" class="button gform-button fb_close_button" type="button"><i class="fa fa-search"></i></button>
                <button v-if="close" style="margin-right: 0.5rem" @click="$emit('closed')" class="button gform-button fb_close_button" type="button"><i class="fa fa-close"></i></button>
            </div>
            <item-lookup @selected="SelectObject($event)" :component="SelectedAction.component.name" :refcomponent="label[0].toUpperCase() + label.substring(1)" ref="lookup"></item-lookup>
            <div v-for="item in Object.keys(object)" v-if="!collapsed">
                <object-display v-if="typeof object[item] === 'object'" :label="item" :object="object[item]"></object-display>
                <field-entry v-else :label="item" v-model="object[item]" @input="$forceUpdate()">{{item}}</field-entry>
            </div>
        </div>
    `
});