/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

Vue.component('dual-condition-field-u', {
    props: ['value'],
    data: function(){
        return {
            operators: ['=','!=','<','>']
        };
    },
    template:
        `<div v-show="value.active" style="width: 100%">
            <div v-show="value.statements.length > 1" class="cwf_all_any">
                Show if <select v-model="value.conjunction" style="width:min-content;">
                    <option value="ALL">All</option>
                    <option value="ANY">Any</option>
                </select> values match.
            </div>

            <multi-statement-field-u v-model="value" v-slot="child" @add-statement="pushDefault($event)">
                <input v-model="child.child.property" type="text">
                <merge-tag-u @chosen="setProperty(child,$event)"></merge-tag-u>
                <select class="cwOperators" style="width: 70px;" v-model="child.child.operator">
                    <option v-for="op in operators" :value="op">{{op}}</option>
                </select>
                <input v-model="child.child.value" type="text">
                <merge-tag-u @chosen="setChild(child,$event)"></merge-tag-u>
            </multi-statement-field-u>
        </div>
    `,
    methods: {
        setChild: function(child, val){
            Vue.set(child.child,'value',val);
        },
        setProperty: function(child,val){
            Vue.set(child.child,'property',val);
        },
        pushDefault: function(arr){
            arr.push({
                property: '',
                operator: '=',
                value: ''
            });
        }
    }
});