/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

Vue.component('request-display', {
    data: function (){
        return{
        }
    },
    computed: {
        ...Vuex.mapGetters(['SelectedAction']),
        ...Vuex.mapState(['RequiredProps'])

    },
    methods:{
        RemoveKey(item){
            delete this.SelectedAction.request[item];
            this.$forceUpdate();
        },
        canClose: function (label) {
            var found = true;
            this.RequiredProps.forEach(el=>{
                if(el === label){
                    found = false;
                }
            })
            return found;
        }
    },
    template: `
        <div>
            <template v-for="item in Object.keys(SelectedAction.request)">
                <array-display v-if="Array.isArray(SelectedAction.request[item])" :label="item" @closed="RemoveKey(item)" :array="SelectedAction.request[item]" class="fb_object_container">
        
                </array-display>
                <object-display v-else-if="typeof SelectedAction.request[item] === 'object'" close="true"  @closed="RemoveKey(item)" :label="item" :object="SelectedAction.request[item]">
                    {{item}}
                </object-display>
                <field-entry v-else :label="item" @input="$forceUpdate()" :close="canClose(item)" @closed="RemoveKey(item)" v-model="SelectedAction.request[item]">
                </field-entry>
            </template>
        </div>
    `
});