/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

Vue.component('add-action', {
    computed: {
        ...Vuex.mapState(['FeedSettings','Components'])
    },
    data: function (){
        return {
            aType: 'Create',
            aComp: '',
            displayAll: false
        }
    },
    methods: {
        fetchComponents: function (){
            this.$store.dispatch('fetchComponents',this.displayAll);
        },
        addAction() {
            if (this.aComp) {
                this.$emit('adding');
                this.$store.dispatch('addAction',{type: this.aType, component: this.aComp})
                    .then(() => {
                        this.$emit('added');
                        this.$refs.selComp.value = '';
                        this.aComp = '';
                    });
            } else {
                alert('Select a Component before adding');
            }
        },
    },
    template: `
        <div>
            <ul class="fb_settings_list">
                <li>
                    <p>Component</p>
                    
                    <select v-model="aComp" ref="selComp">
                        <option v-for="item in Object.keys(Components)" :value="{name: item, endpoint: Components[item]}">{{item}}</option>
                    </select>    
                    <button class="button gform-button gform-button--white" type="button" @click="addAction">Add</button>
                </li>
                <li>
                    <label style="margin-left: 76px;">
                        <input type="checkbox" v-model="displayAll" @change="fetchComponents" style="margin-right: 0;">
                        <span>Show All</span>
                    </label>                    
                </li>
            </ul>
        
        </div>
    `
});