/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

Vue.component('field-select', {
    computed: {
        ...Vuex.mapState(['Settings','Fields'])
    },
    methods: {
        updateActive: function() {
            this.Settings.fields.active = this.Settings.fields.statements.length > 0;
        }
    },
    template: `
        <vue-multiselect style="width: 100%" v-model="Settings.fields.statements" @input="updateActive" :options="Fields" :multiple="true" :taggable="true":hide-selected="true" :option-height="30" :close-on-select="false">
            <template slot="caret">
                <div></div>
            </template>
        </vue-multiselect>
    `
});