/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

Vue.component('label-tooltip', {
    data() {
        return {
            skipLabels: ['Show All']
        }
    },
    props: {
        label: String,
        name: String
    },
    computed: {
        getToolTipText() {
            return {
                'Component': 'Select a ConnectWise component to query. Check Show All to see all components.',
                'Exposed Fields': 'Select one or more fields what will be available in the component. All fields are exposed by default, it is recommended to only expose necessary fields to protect sensitive information.',
                'Limit Results': 'Enter the number of results to be returned (25-1000).',
                'Required Fields': 'These fields are required for the selected component.',
                'Conditions': 'Add one or more conditions to limit the data visible to the client.',
                'Custom Field Conditions': 'Add one or more conditions on custom fields to limit the data visible to the client.',
                'Child Conditions': 'Add one or more conditions on child fields to limit the data visible to the client.',
                'Sorting': 'Select one or more fields to sort on, ascending or descending.',
                'Result Template': 'Format how the results are displayed. Example: "\{name\}: \{addressLine1\}" will display "Testing Company: 123 Test St."'
            }[this.label];
        }
    },
    template: `
        <label :for="this.name">
            {{ this.label }}
            <span v-if="!skipLabels.includes(this.label)" class="cw-tooltip-wrapper">
                <button onclick="return false;" onkeypress="return false;" class="cw-tooltip-icon">
                    <i class="gform-icon gform-icon--question-mark"></i>
                </button>
                <div role="tooltip" class="cw-tooltip">
                    <div class="ui-tooltip-content"><strong>{{ this.label }}</strong><br>{{ getToolTipText }}</div>
                </div>
            </span>
        </label>
    `
});