/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

Vue.component('multi-statement-field-u', {
    props: ['value'],
    template:
        `<div style="margin-left: 1.2rem">
        <div v-for="(item,index) in value.statements" class="cwf_ms_div">
            <slot v-model="value.statements[index]" v-bind:child="item">
            </slot>
            <button type="button" class="cwf_circle_plus minus" @click="removeItem(value.statements,index)"></button>
            <button type="button" class="cwf_circle_plus" @click="addItem(value.statements,index)"></button>
        </div>
    </div>`,
    methods: {
        addItem: function (arr,i){
            this.$emit('add-statement',arr);
        },
        removeItem: function (arr,i){
            if(arr.length>1){
                arr.splice(i,1);
            }
        },
        isLastElement(arr, index){
            return index == arr.length-1
        }
    }
});