/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

Vue.component('safe-checkbox', {
    props: ['value','label'],
    data: function () {
        return {
            GUID: 0,
        }
    },
    methods: {
        uuid: function () {
            return ([1e7]+-1e3+-4e3+-8e3+-1e11).replace(/[018]/g, c =>
                (c ^ crypto.getRandomValues(new Uint8Array(1))[0] & 15 >> c / 4).toString(16)
            );
        }
    },
    created: function () {
        this.GUID = this.uuid();
    },
    template: `
        <div>
            <input :id="GUID" type="checkbox" :value="value" :checked="value" @input="$emit('input',$event.target.checked)" @change="$emit('change',$event)">
            <label-tooltip :label="this.label" :name="GUID"></label-tooltip>
        </div>
    `
});