/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

Vue.component('component-select', {
    data: function () {
        return {
            DisplayAll: false,
            Selected: {},
        }
    },
    watch: {
        Selected: function (select){
            this.$store.dispatch('changeComponent',select);
        }
    },
    computed: {
        ...Vuex.mapState(['Components','Settings'])
    },
    methods: {
        fetchComponents: function (){
            this.$store.dispatch('fetchComponents',this.DisplayAll);
        },
        log: function (thing){
            console.log(thing);
        }
    },
    created: function (){
        this.Selected = this.Settings.cwComponentField;
    },
    beforeUpdate: function (){
        this.Selected = this.Settings.cwComponentField;
    },
    template: `
        <div>
            <select v-model="Selected" id="component_field" style="margin-bottom: 0.25rem;">
                <option disabled selected :value="Settings.cwComponentField">{{Settings.cwComponentField.name}}</option>
                <option v-for="item in Object.keys(Components)" :key="item" :value="{endpoint:Components[item],name:item}">{{item}}</option>
            </select>
            <safe-checkbox label="Show All" v-model="DisplayAll" @change="fetchComponents" type="checkbox" style="text-align: right;"></safe-checkbox>
        </div>
    `
});