/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

Vue.component('condition-field-u', {
    props: ['value','options','field'],
    data: function() {
        return {
            operators: ['=','!=','<','>']
        };
    },
    template:
        `<div v-show="value.active">
            <div v-show="value.statements.length>1" class="cwf_all_any">
                Show if <select v-model="value.conjunction" style="width:min-content;">
                    <option value="ALL">All</option>
                    <option value="ANY">Any</option>
                </select> values match.
            </div>
    
            <multi-statement-field-u v-model="value" v-slot="child" @add-statement="pushDefault($event)">
                <div class="cwf_as_div">
                    <select class="cwf_half_rem_margin" v-model="child.child.property" style="width: 170px;">
                        <option v-for="opt in options" :value="JSON.stringify(opt)">{{opt.name}}</option>
                    </select>
                    <select class="cwf_half_rem_margin" style="width: min-content"  v-model="child.child.operator">
                        <option v-for="op in operators" :value="op">{{op}}</option>
                    </select>
                    <input class="cwf_half_rem_margin" type="text" v-model="child.child.value" style="width: 170px;">
                    <merge-tag-u @chosen="child.child.value=$event"></merge-tag-u>
                </div>
            </multi-statement-field-u>
        </div>
    `,
    methods: {
        pushDefault: function(arr) {
            arr.push({
                property: '{"name":"id","type":"integer"}',
                operator: '=',
                value: ''
            });
        },
    }
});