/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

Vue.component('flyout', {
    props: ['header','description'],
    data: function () {
        return {
            show: false
        }
    },
    methods: {
        toggleFlyout: function (){
            this.show = !this.show;
        }
    },
    template: `
        <div class="cwf_flyout" :class="{open: show}">
            <button class="cwf_close" @click="show=false"><i class="cwf_close_icon"></i></button>
            <header class="cwf_flyout_header">
                <h3>{{header}}</h3>
                <p>{{description}}</p>
                </header>
                <div class="cwf_flyout_body">
                    <slot >
                        
                    </slot>    
                </div>
                        
        </div>
    `
});