/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

Vue.component('advanced-settings', {
    data: function () {
        return {
            show: false
        }
    },
    computed: {
        ...Vuex.mapState(['Settings','Properties','Fields'])
    },
    template: `
        <div>
            <br>
            <div class="cwf_advanced_settings" @click="$refs.testFlyout.toggleFlyout()"><i class="cwf_cog"></i><p style="margin-left: 0.5rem">Show Advanced Options</p></div>
            <flyout ref="testFlyout" header="Advanced ConnectWise Settings" description="Allows you to configure conditions, sorting, and more...">
                <div class="cwf_check_area">
                    <safe-checkbox label="Conditions" v-model="Settings.conditions.active"></safe-checkbox>
                    <condition-field-u v-model="Settings.conditions" :options="Properties.condition"></condition-field-u>
                </div>
                <div class="cwf_check_area" v-if="Properties.custom.length>0">
                    <safe-checkbox label="Custom Field Conditions" v-model="Settings.customFieldConditions.active"></safe-checkbox>
                    <condition-field-u v-model="Settings.customFieldConditions" :options="Properties.custom"></condition-field-u>
                </div>
                <div class="cwf_check_area" v-if="Properties.child.length>0">
                    <safe-checkbox label="Child Conditions" v-model="Settings.childConditions.active"></safe-checkbox>
                    <condition-field-u v-model="Settings.childConditions" :options="Properties.child"></condition-field-u>
                </div>
                <div class="cwf_check_area">
                    <safe-checkbox label="Sorting" v-model="Settings.orderBy.active"></safe-checkbox>
                    <orderby-field-u v-model="Settings.orderBy" :options="Properties.condition"></orderby-field-u>
                </div>
                <div class="cwf_check_area">
                    <safe-checkbox label="Result Template" v-model="Settings.resultsViewTemplate.active"></safe-checkbox>
                    <div style="margin-left: 1.2rem;" class="cwf_ms_div" v-if="Settings.resultsViewTemplate.active">
                        <input type="text" v-model="Settings.resultsViewTemplate.template">
                    </div>
                </div>
            </flyout>
        </div>
    `
});