/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

Vue.component('async-button', {
    data: function () {
        return {
            loading: false,
        }
    },
    methods: {
        finishLoad: function(){
            this.loading = false;
        },
        startLoad: function(){
            this.loading = true;
            this.$emit('click');
        }
    },
    template: `
        <button class="button button-primary" @click="startLoad()"  style="margin: 0.3rem;">
            <div v-show="!loading">
                <slot>
                </slot>
            </div>
            <div v-show="loading" class="fr_loader">
            </div>
        </button>
    `,
});