/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

Vue.component('filter-dropdown', {
    props: ['feeds'],
    data: function () {
        return {
            showFilterBox: false,
            selectedFeed: 'All'
        }
    },
    methods:{
        SetFeedFilter: function(filter){
            this.showFilterBox = false;
            if(!filter){
                this.selectedFeed='All';
                this.$store.commit('changeFilters', {
                    filter: 'feed',
                    value: function(entry) {
                        return true;
                    }
                });
                return;
            }

            this.selectedFeed = filter;
            this.$store.commit('changeFilters', {
                filter: 'feed',
                value: function(entry) {
                    return entry.feed_id == filter;
                }
            });
            
        }
    },
    template: `
    <div>
        <a @click="showFilterBox=!showFilterBox"><i class="fa fa-filter"></i></a>
        <div class="fr_filter_box" v-if="showFilterBox">
            <ul class="fr_filter_list">
                <li>
                    <a @click="SetFeedFilter(false)" :class="{fr_selected_filter: selectedFeed=='All'}">All</a>
                </li>
                <li v-for="item in Object.keys(feeds)">
                    <a @click="SetFeedFilter(item)" :class="{fr_selected_filter: selectedFeed==item}">{{feeds[item]}}</a>
                </li>
            </ul>
        </div>
    </div>
    `,
});






/*
                    <th style="position:relative">
                        Feed Name <a @click="showFilterBox=!showFilterBox"><i class="fa fa-filter"></i></a>
                        <div class="fr_filter_box" v-if="showFilterBox">
                            <ul class="fr_filter_list">
                                <li>
                                    <a @click="SetFeedFilter('All')">All</a>
                                    <div class="fr_notif">{{FeedGetAllFails()}}</div>
                                </li>
                                <li v-for="item in feeds">
                                    <a @click="SetFeedFilter(item.name)">{{item.name}}</a>
                                    <div v-if="FeedGetFails(item)!=0" class="fr_notif">
                                        {{FeedGetFails(item)}}
                                    </div>
                                </li>
                            </ul>
                        </div>
                    </th>
*/