/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

Vue.component('json-viewer', {
    props: ['json','jkey'],
    data: function () {
        return {expanded: []}
    },
    computed: {
       isItem: function(){
           if(typeof this.json == 'object'){
                return false;
           }
           return true;
       }
    },
    methods: {
        ToggleExpanded(index){
            Vue.set(this.expanded, index, !this.expanded[index]);
        },
        ExpandAll(){
            for (let i = 0; i < this.expanded.length; i++) {
                this.expanded[i] = true;
            }
            this.$emit('expand');
            this.$forceUpdate();
        },
        CollapseAll(){
            for (let i = 0; i < this.expanded.length; i++) {
                this.expanded[i] = false;
            }
            this.$emit('collapse');
            this.$forceUpdate();
        }
    },
    created: function(){
        this.$parent.$on('expand', this.ExpandAll);
        this.$parent.$on('collapse', this.CollapseAll);
        if(this.json!=null){   
            Object.keys(this.json).forEach(element => {
                this.expanded.push(false);
            });
        }
    },
    template: `
    <ul class="fr_ol">
        <li class="fr_json" style="padding-left:4rem;" v-if="isItem">{{json}}</li>
        <li class="fr_json" v-if="!isItem" v-for="(item, i) in Object.keys(json)">
            <div style="display:flex;align-items:center;">
                <div class="fr_caret_container"  @click="ToggleExpanded(i)">
               <img class="fr_caret" :class="{expanded: expanded[i]}" src="/wp-content/plugins/gravitywise/public/images/caret.png"/>
               </div>
               <p class="fr_date">
                {{item}}
               </p>
            </div>               
                <json-viewer v-show="expanded[i]"  :json="json[item]" :jkey="item"></json-viewer>
            
        </li>
    </ul>
    `,
});
