/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

Vue.component('retry-header', {
    props: ['filters'],
    data: function () {
        return {
            active: 'All'
        }
    },
    computed: {

    },
    template:
        `
    <thead>
        <tr>
            <th colspan="6">
                Filter by:
                <ul class="fr_hlist">
                    <li><a class="fr_filter_item" :class="{'fr_filter_item_active': 'All' === active}"  @click="filterChanged(undefined)">All</a></li>
                    <li v-for="i in filters"><a class="fr_filter_item" :class="{'fr_filter_item_active': i === active}" @click="filterChanged(i)">{{i}}</a></li>
                </ul>
            </th>
            <th colspan="2">
                Hide Dismissed:
                <input type="checkbox" @input="dismissChanged($event.target.checked)" checked></input>
            </th>
        </tr>
    </thead>
    `,
    methods: {
        dismissChanged(val){
            if(val){
                this.$store.commit('changeFilters',{filter: 'dismissed', value: function(entry){
                    return entry.dismissed==0;
                }});
            }else{
                this.$store.commit('changeFilters',{filter: 'dismissed', value: function(entry){
                    return true;
                }});
            }

        },
        filterChanged(filter) {
            this.$emit('clear');

            if (filter == undefined) {
                this.active = 'All';
                this.$store.commit('changeFilters',{filter: 'status', value: function(entry){
                    return true;
                }});
                return;
            }

            this.active = filter;
            this.$store.commit('changeFilters',{filter: 'status', value: function(entry){
                return entry.status == filter;
            }});

        }
    }
});