/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

Vue.component('status-icon', {
    props: ['status','dismissed'],
    data: function () {
        return {}
    },
    computed: {
        StatusIconURI: function () {
            return `/wp-content/plugins/gravitywise/public/images/${this.status}.svg`;
        },
        Tooltip: function () {
            return {
                'Success': `This item has been successfully processed and is now in ConnectWise. No further action is required.`,
                'Fail': `ConnectWise has responded to this item with errors. Please read error logs then retry.`,
                'No Connection': `Could not establish a connection to ConnectWise. Please try again later.`,
                'Wait': `This item is currently waiting to be processed. No further action is required.`,
                'Duplicate': `A duplicate has been found in ConnectWise. Please select how to proceed.`,
                'Reverted': `The item has been successfully removed from ConnectWise. No further action is required.`,
                'No Condition': `The item has not met the conditions described in the feed builder. No further actions are required.`,
                'Dismissed': 'The item has been dismissed.'
            }[this.status];

        }
    },
    template: `
    <div style="display:flex;position: relative;">
        <img class="fr_status_icon" :class="{fr_dismissed_filter: dismissed}" :src="StatusIconURI">
        <div class="fr_tooltip">
            {{Tooltip}}
        </div>
    </div>
    `,
});




