/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

import '/../wp-content/plugins/gravitywise/public/js/vue/retry/components/atoms/note-card.js';
import '/../wp-content/plugins/gravitywise/public/js/vue/retry/components/molecules/retry-feed-head.js';
import '/../wp-content/plugins/gravitywise/public/js/vue/retry/components/atoms/action-card.js';


Vue.component('entry-details',{
    props: ['selected'],
    data: function(){
        return {
        }
    },
    template:`
    <tr>
    <td colspan="8" style="overflow: hidden" v-if="selectedEntry==undefined && selected!=-1">
        <div class="flat_loader" style="height:100%"></div>
    </td>
    <td colspan="8" v-if="selected!=-1 && selectedEntry!=undefined">
        <div class="fr_entry_details">
            <div class="fr_flex_1">
                <table class="fr_details_table fr_entries_table">
                    <tr>
                        <th colspan="2">Entry Details</th>
                    </tr>
                    <tr>
                        <td>Entry Id:</td>
                        <td>{{selectedEntry.details.id}}</td>
                    </tr>
                    <tr>
                        <td>Submitted On:</td>
                        <td>{{selectedEntry.details.date_created}}</td>
                    </tr>
                    <tr>
                        <td>Updated On:</td>
                        <td>{{selectedEntry.details.date_updated}}</td>
                    </tr>
                    <tr>
                        <td>User IP:</td>
                        <td>{{selectedEntry.details.ip}}</td>
                    </tr>
                </table>
            </div>
            <div class="fr_flex_1">
                <div class="fr_notes_header">
                    Notes
                </div>
                <div class="fr_notes_pane">
                    <ul style="margin: 0">
                        <li is="retry-table-note-card" v-for="note in selectedEntry.notes" :note="note" :key="note.id">
                        </li>

                    </ul>
                </div>
            </div>
        </div>
        <div>
            <ul>
                <li v-for="action, i in selectedEntry.actions" :key="action.id">
                    <retry-feed-head :name="'Step '+(parseInt(action.meta_key)+1)+' - Create Record in '+JSON.parse(action.meta)['component']['name']" :status="action.status" >
                        <action-card :actionid="i"></action-card>
                    </retry-feed-head>
                </li>
            </ul>
        </div>
    </td></tr>
    `,
    computed: {...Vuex.mapState(['selectedEntry']),
            ...Vuex.mapGetters(['filteredEntries'])},
    watch: {
        selected: function(newVal, oldVal){
            if(newVal!=-1){
                for (const k in this.filteredEntries) {
                    const b = this.filteredEntries[k];
                    if(b.entry_id===newVal){
                        this.$store.dispatch('fetchDetails', {entryId:b.entry_id,feedId:b.feed_id});
                    }
                }


            }
        }   
    }

});