/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

import '/../wp-content/plugins/gravitywise/public/js/vue/retry/components/atoms/status-icon.js';

Vue.component('entry',{
    props: ['entry'],
    data: function(){
        return {}
    },
    computed:{
        FeedName: function(){
            return JSON.parse(this.entry.feed_meta).name;
        },
        StatusClass: function () {
            if(this.entry.condition_validated == 'False'){
                return {'fr_success': true};
            }
            var res = {};
            res[{
                'Success': 'fr_success',
                'No Condition': 'fr_success',
                'Fail': 'fr_fail',
                'Wait': 'fr_wait',
                'No Connection': 'fr_no_connection',
                'Duplicate' : 'fr_fail',
                'Dismissed' : 'fr_dismissed'
            }[this.entry.status]] = true;
            return res;
        }
    },
    template:`
        <tr>
            <td :class="StatusClass">

            </td>
            <td>
                <a :href="'/wp-admin/admin.php?page=gf_edit_forms&view=settings&subview=gravitywise&id='+entry.form_id+'&fid='+entry.feed_id">
                {{FeedName}}
                </a>
            </td>
            <td>
                <a :href="'/wp-admin/admin.php?page=gf_edit_forms&id='+entry.form_id">
                    {{entry.form_name}}
                </a>
            </td>
            <td >
                <a :href="'/wp-admin/admin.php?page=gf_entries&view=entry&id='+entry.form_id+'&lid='+entry.entry_id">
                    Entry {{entry.entry_id}}
                </a>
            </td>
            <td>
                {{entry.date_created}}
            </td>
            <td>
                {{entry.current_status}}/{{entry.total_status}}
            </td>
            <td style="padding:0; width:2rem;">
                <status-icon :status="entry.condition_validated=='False'?'No Condition':entry.status" :dismissed="entry.dismissed==1"></status-icon>
            </td>
            <td class="fr_action_td">
                <a><i class="fa fa-eye" @click="selectEntry" title="Select"></i></a>
                <a><i class="fa fa-ban" v-if="entry.dismissed==0" @click="dismissEntry" title="Dismiss"></i></a>
                <a><i class="fa fa-reply" v-if="entry.dismissed==1" @click="restoreEntry" title="Restore"></i></a>
                <a><i class="fa fa-trash" v-if="entry.dismissed==1" @click="deleteEntry" title="Delete"></i></a>
            </td>
        </tr>
    `,
    methods: {
        selectEntry: function(){
            this.$emit('selected');
        },
        restoreEntry: async function(){
            document.body.style.cursor='wait';
            await this.$store.dispatch('dismissEntry',{id:this.entry.id,op:'restore'});
            document.body.style.cursor='default';
        },
        dismissEntry: async function(){
            document.body.style.cursor='wait';
            await this.$store.dispatch('dismissEntry',{id:this.entry.id,op:'dismiss'});
            document.body.style.cursor='default';
        },
        deleteEntry: async function(){
            document.body.style.cursor='wait';
            await this.$store.dispatch('dismissEntry',{id:this.entry.id,op:'delete'});
            document.body.style.cursor='default';
        }
    }
});