/************************************************************************************************
 * © Copyright 2021, BizZToolz
 * Use of this code is permitted under the terms of the GNU Lesser General Public License
 * https://www.fsf.org/
 ************************************************************************************************/

Vue.component('retry-feed-head', {
    props: ['name', 'date', 'status', 'failedcount'],
    data: function () {
        return {
            expanded: false,
            
        }
    },
    computed: {
        _date: function () {
            if (this.date != undefined) {
                return this.date;
            }
            return "";
        },
        statusClass: function(){
            return{
                "fr_success": this.status == 'Success',
                "fr_fail": this.status == 'Fail' || this.status == 'Duplicate',
                "fr_wait": this.status == 'Wait',
                "fr_dismissed": this.status == 'Dismissed',
                "fr_no_connection": this.status === 'No Connection'
            }
        }
    },
    template: `
    <div>
        <div class="fr_header feed">
            <div class="fr_float_left">
                <div class="fr_status_bar" :class="statusClass"></div>
                <div class="fr_caret_container"  @click="expanded=!expanded">
                    <img class="fr_caret" :class="{expanded: expanded}" src="/wp-content/plugins/gravitywise/public/images/caret.png"/>
                </div>
                <h3 class="fr_entry_heading">{{name}}</h3>
                <p class="fr_date">{{_date}}</p>
            </div>
            <div class="fr_float_right fr_status" :class="statusClass">
                <h3 class="fr_entry_heading">
                    {{status}}
                </h3>                     
            </div>
        </div>
        <div class="fr_child_root">
            <div class="fr_child_guideline">

            </div>
            <div class="fr_child_container" v-if="expanded">
                <slot>
                </slot>
            </div>
        </div>
    </div>`,
    methods: {

    }
});