<!--************************************************************************************************-->
<!-- © Copyright 2021, BizZToolz-->
<!-- Use of this code is permitted under the terms of the GNU Lesser General Public License-->
<!-- https://www.fsf.org/-->
<!--************************************************************************************************-->


<div id="VueFeedRetry">
    <div class="fr_main_container">
        <div>
            <div style="display: flex; justify-content:space-between;align-items:center;">
                <h1>GravityWise Feed History</h1>
                <async-button class="button button-primary" @click="refresh()" ref="refresh">Refresh</async-button>
            </div>
            <retry-table></retry-table>
        </div>
    </div>
</div>

<?php
include ABSPATH . 'wp-content/plugins/gravitywise/includes/api/feed-retry/process-feeds.php';
?>

<script type="module">
    import store from '/../wp-content/plugins/gravitywise/public/js/vue/retry/state/store.js';
    import '/../wp-content/plugins/gravitywise/public/js/vue/retry/components/organisms/retry-table.js';
    import '/../wp-content/plugins/gravitywise/public/js/vue/retry/components/atoms/async-button.js';

    var VueFeedBuilder = new Vue({
        el: '#VueFeedRetry',
        store,
        methods: {
            refresh: async function() {
                await this.$store.dispatch('fetchEntries');
                this.$refs.refresh.finishLoad();
            }
        },
        created() {
            const queryString = window.location.search;
            const urlParams = new URLSearchParams(queryString);
            if (urlParams.has('feed_id')) {
                const feed_id = urlParams.get('feed_id');

                this.$store.commit('changeFilters', {
                    filter: 'feed',
                    value: function(entry) {
                        return entry.feed_id == feed_id;
                    }
                });
            } else {
                this.$store.commit('changeFilters', {
                    filter: 'dismissed',
                    value: function(entry) {
                        return entry.dismissed == 0;
                    }
                });
            }
        }
    });
</script>