<!--************************************************************************************************-->
<!-- © Copyright 2021, BizZToolz-->
<!-- Use of this code is permitted under the terms of the GNU Lesser General Public License-->
<!-- https://www.fsf.org/-->
<!--************************************************************************************************-->


<div id="VueDuplicateCheck">
    <h1>
        Duplicate Check
    </h1>
    <h2>
        Company
    </h2>
    <table>
        <tr>
            <td>
                Identifier
            </td>
            <td>
                <input type="text" v-model="request.identifier"></input>
            </td>
        </tr>
        <tr>
            <td>
                Name
            </td>
            <td>
                <input type="text" v-model="request.name"></input>
            </td>
        </tr>
        <tr>
            <td colspan="2">
            Address Details
            </td>
        </tr>
        <tr>
            <td>
                Address Line 1
            </td>
            <td>
                <input type="text" v-model="request.addressLine1"></input>
            </td>
        </tr>
        <tr>
            <td>
                City
            </td>
            <td>
                <input type="text" v-model="request.city"></input>
            </td>
        </tr>
        <tr>
            <td>
                State
            </td>
            <td>
                <input type="text" v-model="request.state"></input>
            </td>
        </tr>
        <tr>
            <td>
                Zip
            </td>
            <td>
                <input type="text" v-model="request.zip"></input>
            </td>
        </tr>
        <tr>
            <td colspan="2">
            Other Details
            </td>
        </tr>
        <tr>
            <td>
                Phone Number
            </td>
            <td>
                <input type="text" v-model="request.phoneNumber"></input>
            </td>
        </tr>
        <tr>
            <td>
                Fax Number
            </td>
            <td>
                <input type="text" v-model="request.faxNumber"></input>
            </td>
        </tr>
        <tr>
            <td>
                Website
            </td>
            <td>
                <input type="text" v-model="request.website"></input>
            </td>
        </tr>
    </table>
    <button type="button" @click="checkDuplicate">Check</button>
    <ul>
        <li v-for="item in m">
            {{item}}
        </li>
    </ul>
    
</div>

<script type="text/javascript">
    var VueFeedBuilder = new Vue({
        el: '#VueDuplicateCheck',
        methods: {
           checkDuplicate: async function(){
               var response = await fetch('/wp-content/plugins/gravitywise/includes/api/feed-retry/test-duplicate.php', {
                   method: 'POST',
                   headers: {
                       'Content-Type': 'application/json'
                   },
                   body: this.json
               });
               this.result = await response.text();
               this.m =  this.result.split('—');
           }
        },
        computed: {
            json: function(){
                return JSON.stringify(this.request, null, 2);
            }
        },
        data: {
            result: "No duplicate found",
            request: {
                "identifier": "BNG Team",
                "name": "BNG Team",
                "addressLine1": "3285 47th Street S",
                "city": "Fargo",
                "state": "ND",
                "zip": "58104",
                "phoneNumber": "7015263539",
                "faxNumber": "8886362030",
                "website": "www.bngteam.com"
            },
            m: []
        }
    });
</script>